/*


							Reprsentation de molcules en 3D programm par
									Jason Kealey et Guillaume Alain 
			en C++ avec Allegro, de la cafne et Nine Inch Nails jouant dans l'arrire-plan.

Ceci est notre projet de fin de DEC (chimie/mathmatiques/informatique) pour le Collge de l'Outaouais. 
							 Programm dans les cinq premiers mois de 2001.

						web: http://www.shade.ca/coding/3dmol/default.asp?lg=fr
                      courriel: jkealey@shade.ca ou galain@shade.ca


												  --


									3D molecule representation coded by
									  Jason Kealey and Guillaume Alain 
				in C++ with Allegro, cafne and Nine Inch Nails playing in the background.

This is our end of DEC (in chemistry/mathematics/computer science) project for the Collge de l'Outaouais.
									Coded in the first five months of 2001.

							web: http://www.shade.ca/coding/3dmol/default.asp?lg=en
                      email: jkealey@shade.ca or galain@shade.ca



*/





// external libraries
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "allegro.h"

// allegro can minimize .exe size
// doesn`t minimize much if you ask me.

BEGIN_COLOR_DEPTH_LIST
COLOR_DEPTH_8
COLOR_DEPTH_15
COLOR_DEPTH_16
COLOR_DEPTH_24
COLOR_DEPTH_32
END_COLOR_DEPTH_LIST

// no music
BEGIN_DIGI_DRIVER_LIST
END_DIGI_DRIVER_LIST

BEGIN_MIDI_DRIVER_LIST
END_MIDI_DRIVER_LIST

// our classes
#include "definitions.cpp"
#include "points.cpp"
#include "face.cpp"
#include "shape3d.cpp"
#include "moleculelink.cpp"
#include "molecule3d.cpp"




int main()
{
	// initialisation
	allegro_init();
    install_keyboard(); 
    set_standard_keyboard();

	// fill sin and cos table
	init_trigo();

	// standard 1024x768
	// set_gfx_mode(GFX_VESA1, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0); 

	/* set the best color depth that we can find (code from allegro examples)*/
	set_color_depth(16);
	if (set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0) 
	   {
	   set_color_depth(15);
	   if (set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0) 
	 	{
	 	set_color_depth(32);
	 	if (set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0) 
	 		{
	 		set_color_depth(24);
	 		if (set_gfx_mode(GFX_AUTODETECT, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0) != 0) 
	 			{
	 			allegro_exit();
	 			printf("Error setting graphics mode\n%s\n\n", allegro_error);
	 			return 1;
	 			}
	 		}
	 	}
	}

	/* load all images in the same color depth as the display */
	set_color_conversion(COLORCONV_TOTAL);
   
	// some variables
	int c=0,i=0,j=0;
	int whichmolecule=0, highlightedatom=0;
		
	// buffer will be blit to screen
	BITMAP *buffer;
	buffer = create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);

		
		
	// BEGIN JOYSTICK INITIALISATION CODE	(from allegro examples)	
		// for joystick
		int analogmode;
		char *msg;
		float lastxpos=0, lastypos=0;
		
		// the first thing is to initialise the joystick driver
		if (install_joystick(JOY_TYPE_AUTODETECT) != 0) {
		   printf("\nError initialising joystick\n%s\n\n", allegro_error);
		}
		// make sure that we really do have a joystick
		if (joy_type == JOY_TYPE_NONE) {
		   printf("\nError: joystick not found\n\n");
		}

		/* before using the joystick, we have to calibrate it. This loop only
		 * calibrates joystick number 0, but you could do the same thing for
		 * other sticks if they are present (the num_joysticks variable will 
		 * tell you how many there are).
		 */


		// we won't calibrate the joystick, if we do, we have some problems with fluid movement using one of the arrows in analog mode.
		/*
			while (joy[0].flags & JOYFLAG_CALIBRATE) {
			   msg = calibrate_joystick_name(0);
			   printf("%s and press a key.\n", msg);

			   if ((readkey()&0xFF) == 27)
			  return 0;

			   if (calibrate_joystick(0) != 0) {
			  printf("\nError calibrating joystick!\n\n");
			  return 1;
			   }
			}

			printf("\n%s has been initialised and calibrated.\n\n", joystick_driver->name);
		*/


		/* if this joystick supports analogue input, use analogue mode.
		 * If it is only a digital pad, use digital mode. */
		analogmode = (joy[0].stick[0].flags & JOYFLAG_ANALOGUE) ? TRUE: FALSE;
   
	// END JOYSTICK INITIALISATION CODE	






	/*	BEGIN ATOM LIST
	
		0: CH4
		1: C2H4
		2: C2H2
		3: C6H6
		4: C6H12 (BATEAU)
		5: C6H12 (CHAISE)
		6: NH2-R-SO2-NH2
		7: NH2-R-CO-CH2-CH3
		8: NH2-R-CO-O-CH2-CH3
		9: TEXT
		
		END ATOM LIST	*/




	// with which molecule should we start	
	molecule3D myMolecule(whichmolecule);
	

	clear(buffer);
	PALETTE pal;
	get_palette(pal);
	buffer = load_bmp("keyb.bmp", pal);
	vsync();
	blit(buffer, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT); 

	

	   
	do
		{
		// if we don't have a character, read one from the buffer
		c= (c) ? c : readkey();

		// when should we quit the program?
		if ( (c & 0xFF)=='q' || (c & 0xFF) =='Q' || (c & 0xFF)==27 ) break;


		// all regular keyboard triggers are here
		switch(c & 0xFF)
			{

			// rotations around axises
			case '4':
				myMolecule.rotateall(0,-0.1,0);
				break;
			case '6':
				myMolecule.rotateall(0,0.1,0);
				break;
			case '2':
				myMolecule.rotateall(-0.1,0,0);			
				break;
			case '8':
				myMolecule.rotateall(0.1,0,0);			
				break;
			case '0':
				myMolecule.rotateall(0,0,-0.1);			
				break;			
			case '.':
				myMolecule.rotateall(0,0,0.1);			
				break;			
			case '9':
				myMolecule.rotateall(0.1,0.1,0);		
				break;			
			case '7':
				myMolecule.rotateall(0.1,-0.1,0);					
				break;			
			case '1':
				myMolecule.rotateall(-0.1,-0.1,0);		
				break;			
			case '3':
				myMolecule.rotateall(-0.1,0.1,0);		
				break;	
			case '5':
				myMolecule.rotateall(0.1,0.1,0.1);
				break;
				
			// moves the molecule. however it keeps turning around itself
			case '+':
				//myMolecule.translateall(0,0,50);
				ZFIXFACTOR+=50;
				break;			
			case '-':
				//myMolecule.translateall(0,0,-50);
				ZFIXFACTOR-=50;
				break;			
			case 'k':
				//myMolecule.translateall(10,10,0);
				XFIXFACTOR+=50;
				break;			
			case 'j':
				//myMolecule.translateall(-10,-10,0);
				XFIXFACTOR-=50;
				break;					
			case 'i':
				//myMolecule.translateall(10,10,0);
				YFIXFACTOR+=50;
				break;			
			case 'm':
				//myMolecule.translateall(-10,-10,0);
				YFIXFACTOR-=50;
				break;					

			// moves the molecule and makes it turn around the origin of the world
			case '/':
				myMolecule.translateall(0,0,50);
				break;			
			case '*':
				myMolecule.translateall(0,0,-50);
				break;			
			case 'g':
				myMolecule.translateall(10,0,0);
				break;			
			case 'f':
				myMolecule.translateall(-10,0,0);
				break;					
			case 't':
				myMolecule.translateall(0,10,0);
				break;			
			case 'v':
				myMolecule.translateall(0,-10,0);
				break;		


			// other hot keys
			
			// toggle highlighting			
			case '\r':

				// if a molecule is highlighted, un-highlight
				
				if (highlightedatom>0 && myMolecule.atomlist[highlightedatom-1].currentatom>1000) myMolecule.atomlist[highlightedatom-1].currentatom-=1000;
				

				// toggles highlighting
				highlightedatom = (highlightedatom?0:1);

				// if highlighting is activated, highlight the first one.
				if (highlightedatom) myMolecule.atomlist[0].currentatom+=1000;

				break;
			

			// move backwards in highlighting
			case 'a':
				// is highlighting activated?
				if (highlightedatom)
					{
					// un-highlight current atom
					if (myMolecule.atomlist[highlightedatom-1].currentatom>1000) myMolecule.atomlist[highlightedatom-1].currentatom-=1000;
					
					if (highlightedatom!=1)
						{
						// if all but first atom, highlight the previous one
						highlightedatom--;
						myMolecule.atomlist[highlightedatom-1].currentatom+=1000;
						}
					else
						{
						// if is the first atom, highlight the last one.
						highlightedatom=myMolecule.nbofatomsinmolecule;
						myMolecule.atomlist[highlightedatom-1].currentatom+=1000;
						}
					}
				break;


			// move forwards in highlighting
			case 's':
				// is highlighting activated?
				if (highlightedatom)
					{
					// un-highlight current atom
					if (myMolecule.atomlist[highlightedatom-1].currentatom>1000) myMolecule.atomlist[highlightedatom-1].currentatom-=1000;

					if (highlightedatom!=myMolecule.nbofatomsinmolecule)
						{
						// if all but last atom, highlight the next one
						highlightedatom++;
						myMolecule.atomlist[highlightedatom-1].currentatom+=1000;
						}
					else
						{
						// if is the last atom, highlight the first one.
						highlightedatom=1;
						myMolecule.atomlist[highlightedatom-1].currentatom+=1000;
						}
					}
				break;			


			// runtime type switching
			case '\t':
				myMolecule.destroyatoms();
				for (i=0;i<myMolecule.nbofatomsinmolecule;i++)
					{

					// case i+1000 are highlighted atoms
					switch(myMolecule.atomlist[i].currentatom)
						{
						case 1001:
						case 1:
							// hydrogen
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(46);
								//myMolecule.atomlist[i].setasprofchimie(5);
							else
								myMolecule.atomlist[i].setascube(67);
							break;

						case 1006:
						case 6:
							// carbon
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(118);
							else
								myMolecule.atomlist[i].setascube(172);
							break;
							
						case 1007:
						case 7:
							// nitrogen																		
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(97);
							else
								myMolecule.atomlist[i].setascube(141);
							break;
							
						case 1008:
						case 8:
							// oxygen
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(91);
							else
								myMolecule.atomlist[i].setascube(132);
							break;
							
						case 1016:
						case 16:
							// sulfur
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(144);
							else
								myMolecule.atomlist[i].setascube(209);
							break;						
							
						case 1500:
						case 500:
							// electrons
							if (myMolecule.atomlist[i].currentshapetype==2)
								myMolecule.atomlist[i].setaspseudosphere(10);
							else
								myMolecule.atomlist[i].setascube(15);
							break;	
						}

						
					}
					
				break;

			// runtime molecule changing			
			case ' ':
				// deactivate highlighting
				highlightedatom=0;
								
				// set it to starting coordinates
				XFIXFACTOR=0;
				YFIXFACTOR=0;
				ZFIXFACTOR=0;

				// free memory
				myMolecule.destroyatoms();
				myMolecule.destroymolecule();				


				// change molecule
				whichmolecule++;
				if (whichmolecule>9) { whichmolecule=0; }
				myMolecule.setas(whichmolecule);

				break;
			}
		

		// extended keyboard key triggers
		switch(c>>8)
			{
			case KEY_LEFT:
				XFIXFACTOR-=50;
				break;
			case KEY_RIGHT:
				XFIXFACTOR+=50;
				break;
			case KEY_DOWN:
				YFIXFACTOR-=50;
				break;
			case KEY_UP:
				YFIXFACTOR+=50;
				break;
			}


		// joystick triggers
		do
			{
			
			// do we have a joystick present ?
			if (joy_type != JOY_TYPE_NONE) 
				{
				// save last positions
				lastxpos=joy[0].stick[0].axis[0].pos;
				lastypos=joy[0].stick[0].axis[1].pos;

			
				// get new positions
				poll_joystick(); 

				// if joystick has moved or a key has been pressed
				if (c!=0 || joy[0].stick[0].axis[0].pos != lastxpos || joy[0].stick[0].axis[1].pos/40 != lastypos)
					{			
					// if no keys have been pressed (don't parse this code if you are waiting for the keypress to be displayed
					if (!c)
						{
						
						// movement checking
						// if joystick is in analog mode
						if (!analogmode) 
							{
							// check for movements
							if (joy[0].stick[0].axis[1].d1) myMolecule.rotateall(-0.1,0,0);
							if (joy[0].stick[0].axis[1].d2) myMolecule.rotateall(0.1,0,0);
							if (joy[0].stick[0].axis[0].d1) myMolecule.rotateall(0,-0.1,0);
							if (joy[0].stick[0].axis[0].d2) myMolecule.rotateall(0,0.1,0);
							}			
						
						else // if joystick is in digital mode
							{
							// check for movements
							if (joy[0].stick[0].axis[1].pos < 0) myMolecule.rotateall(-0.1,0,0);
							if (joy[0].stick[0].axis[1].pos > 0) myMolecule.rotateall(0.1,0,0);
							if (joy[0].stick[0].axis[0].pos < 0) myMolecule.rotateall(0,-0.1,0);
							if (joy[0].stick[0].axis[0].pos > 0) myMolecule.rotateall(0,0.1,0);
							}

						// button checking
						for (i=0; i<joy[0].num_buttons; i++)
							{

							// if button pressed
							if (joy[0].button[i].b)
								{
								// if button1 is pressed, set the character to type changing
								if (strcmp(joy[0].button[i].name,"B1")==0)
									{
									c='\t';
									}
									
								// if button2 is pressed, set the character to molecule changing
								if (strcmp(joy[0].button[i].name,"B2")==0)
									{
									c=' ';
									}
									
								}


							} // end for

						}
					else 
						{
						// if a key has been pressed, forget it.
						c=0;
						}
					}

				}
			else 
				{
				// there is no joystick present, erase the character, exiting the joystick loop
				c=0;
				}
				
			
			// display molecule to buffer (could be put into a function
			clear(buffer);					
				
			myMolecule.generateall();
			myMolecule.displayall(buffer);
			vsync();
			blit(buffer, screen, 0, 0, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT); 

			// if a key has been pressed OR a pseudo-character has been set by joystick buttons, break			
			} while (!keypressed() && !c);

		// if the key is escape or q, quit the program, else start over drawing the molecule once again
		} while ( (c & 0xFF) !='q' && (c & 0xFF) !='Q' && (c & 0xFF)!=27 );



  // used to save screen captures
  // save_bitmap("dump.pcx", buffer, pal);

  clear(buffer);

	// destroys all atoms, then destroys the list.
	myMolecule.destroyatoms();
	myMolecule.destroymolecule();


	// clear video memory
	destroy_bitmap(buffer);

	// exit functions
	allegro_exit();
	return 0;
}


