
// molecule class

class molecule3D
{
	public:
	// variables
	int nbofatomsinmolecule;
	int nboflinksinmolecule;

	// bunch of atoms
	shape3D *atomlist;
	
	moleculelink *atomlinklist;
	
	// ch2, c2h4, c2h2, etc.
	int currentmoleculetype;
	
	// functions
	molecule3D(void) { nbofatomsinmolecule=0; nboflinksinmolecule=0; currentmoleculetype=0;}
	molecule3D(int which) { setas(which); }
	molecule3D(int atoms, int links) { init(atoms, links); }
	~molecule3D(void) { destroyatoms(); destroymolecule(); }
	
	void init(int atoms, int links);
	void destroyatoms(void);
	void destroymolecule(void);
	
	void displayall(BITMAP *bitmap);
	void generateall(void);
	void rotateall(float x, float y, float z);
	void translateall(float x, float y, float z);
	
	void setas(int which);
};



// init memory
void molecule3D::init(int atoms, int links)
{
	nbofatomsinmolecule=atoms;
	nboflinksinmolecule=links;

	atomlist = new shape3D[nbofatomsinmolecule];
	atomlinklist = new moleculelink[nboflinksinmolecule];
}




// clear memory (deletes every shape)
void molecule3D::destroyatoms(void)
{
	int i;
	for (i=0;i<nbofatomsinmolecule;i++)
		{
		atomlist[i].setasnothing();
		}
}


// clear memory (deletes the molecule)
void molecule3D::destroymolecule(void)
{
	delete [] atomlist;
	atomlist=0;

	delete [] atomlinklist;
	atomlinklist=0;
	
	nbofatomsinmolecule=0;
	nboflinksinmolecule=0;
	currentmoleculetype=0;
}





void molecule3D::displayall(BITMAP *bitmap)
{
	
	int i, j;

	int *order;
	order = new int[nbofatomsinmolecule];

	int orderval = 0;

	int iDraw;
	float x1,y1,z1,x2,y2,z2,m;


	// set the coordinates for the links to be drawn
	for (i=0;i<nboflinksinmolecule;i++)
		{

		iDraw=0;

		if ( (atomlist[atomlinklist[i].mol1].originalignedcoords.z < 1 && atomlist[atomlinklist[i].mol2].originalignedcoords.z >=1) || (atomlist[atomlinklist[i].mol1].originalignedcoords.z >= 1 && atomlist[atomlinklist[i].mol2].originalignedcoords.z <1) )
			{
			// half in, half out
			x1=atomlist[atomlinklist[i].mol1].originalignedcoords.x;
			y1=atomlist[atomlinklist[i].mol1].originalignedcoords.y;
			z1=atomlist[atomlinklist[i].mol1].originalignedcoords.z;

			x2=atomlist[atomlinklist[i].mol2].originalignedcoords.x;
			y2=atomlist[atomlinklist[i].mol2].originalignedcoords.y;
			z2=atomlist[atomlinklist[i].mol2].originalignedcoords.z;


			if (z1>z2)
				{

				m = (z1-z2) ? (10-z2)/(z1-z2) : (10-z2);			
				
				// define new aligned coords
				atomlist[atomlinklist[i].mol2].originalignedcoords.x = x2+(x1-x2)*m;
				atomlist[atomlinklist[i].mol2].originalignedcoords.y= y2+(y1-y2)*m;
				atomlist[atomlinklist[i].mol2].originalignedcoords.z = 1;
				
				// generate the screen coords from those aligned coords
				atomlist[atomlinklist[i].mol2].generatescreencoords();
				
			}
			else
				{
				m = (z2-z1) ? (1-z1)/(z2-z1) : (1-z1);			

				// define new aligned coords
				atomlist[atomlinklist[i].mol1].originalignedcoords.x = x1+(x2-x1)*m;
				atomlist[atomlinklist[i].mol1].originalignedcoords.y= y1+(y2-y1)*m;
				atomlist[atomlinklist[i].mol1].originalignedcoords.z = 1;

				// generate the screen coords from those aligned coords
				atomlist[atomlinklist[i].mol1].generatescreencoords();

				}
			
			iDraw=1;
			}
		else
			{
			if ( atomlist[atomlinklist[i].mol1].originalignedcoords.z >= 1 && atomlist[atomlinklist[i].mol2].originalignedcoords.z >=1 )
				{
				// all in
				iDraw=1;
				}
			}


 		
 		// draw links (we do this before we draw the atoms because we don't want them drawn on them). 
 		// these links are in 2D... sometimes doubles or triples might appear as singles, depending on the viewing angle
 		if (iDraw)
			{
			if (atomlinklist[i].type == 1) // simple
				{
				line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y,makecol(240,240,240));
				line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+1, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+1,makecol(240,240,240));
				line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-1, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-1,makecol(240,240,240));
				}
			else 
				{
				if (atomlinklist[i].type == 2) // double
					{
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-5, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-5,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-4, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-4,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-6, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-6,makecol(240,240,240));

					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+5, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+5,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+6, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+6,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+4, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+4,makecol(240,240,240));
					}
				else		// triple
					{
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-10, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-10,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-9, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-9,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-11, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-11,makecol(240,240,240));

					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+1, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+1,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y-1, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y-1,makecol(240,240,240));

					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+10, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+10,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+11, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+11,makecol(240,240,240));
					line(bitmap, (int) atomlist[atomlinklist[i].mol1].originscreencoords.x, (int)atomlist[atomlinklist[i].mol1].originscreencoords.y+9, (int)atomlist[atomlinklist[i].mol2].originscreencoords.x, (int)atomlist[atomlinklist[i].mol2].originscreencoords.y+9,makecol(240,240,240));

					}
				}
	
			}
		}



	// quick z-buffering; we assumed that our atoms would be far away from each other.... only check the origins and not every point
	for(i = 0; i < nbofatomsinmolecule ; i++)
	{
	   orderval = 0;
	   for(j = 0; j < nbofatomsinmolecule; j++)
	   {
	      if( atomlist[i].originalignedcoords.z < atomlist[j].originalignedcoords.z ) orderval++;      
	   }

	   order[i]=orderval;

	}

	orderval=0;
	
	for (orderval=0; orderval<nbofatomsinmolecule;orderval++)
	{
		for (i=0;i<nbofatomsinmolecule;i++)
			{
			if (orderval==order[i]) atomlist[i].displayshape(bitmap);
			}
	}
	
	
	// clear memory
	delete [] order;
	order=0;
}





// generates all coords
void molecule3D::generateall(void)
{
	for (int i=0;i<nbofatomsinmolecule;i++)
		{
		atomlist[i].generateallcoords();
		}
}



// increments the rotation values for every atom
void molecule3D::rotateall(float x, float y, float z)
{
	for (int i=0;i<nbofatomsinmolecule;i++)
		{
		atomlist[i].setallrotations(x,y,z);
		/*
		atomlist[i].rx =x*35;
		atomlist[i].ry =y*35;
		atomlist[i].rz =z*35;
		*/
		}
		
}



// increments the translation values for every atom
void molecule3D::translateall(float x, float y, float z)
{
	for (int i=0;i<nbofatomsinmolecule;i++)
		{
		atomlist[i].originworldcoords.x +=x;
		atomlist[i].originworldcoords.y +=y;
		atomlist[i].originworldcoords.z +=z;
		}
}





// which molecule?
void molecule3D::setas(int which)
{
	
	currentmoleculetype=which;
	
	extern int ZFIXFACTOR;
						
	switch(which)
		{
		case 0:

			//    BEGIN CH4 MOLECULE


			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=500;
					
			init(5,4);
						
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(0,0,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(46);
			atomlist[1].setoriginworldcoords(0,301.6,0);
			atomlist[1].currentatom = 1; // hydrogen
		
			atomlist[2].setaspseudosphere(46);
			atomlist[2].setoriginworldcoords(-245.54,-98.19,-145.03);
			atomlist[2].currentatom = 1; // hydrogen

			atomlist[3].setaspseudosphere(46);
			atomlist[3].setoriginworldcoords(245.54,-98.19,-145.03);
			atomlist[3].currentatom = 1; // hydrogen
		
			atomlist[4].setaspseudosphere(46);
			atomlist[4].setoriginworldcoords(0,-98.19,285.19);
			atomlist[4].currentatom = 1; // hydrogen		
		
		
			atomlinklist[0].setlink(0,1,1);
			atomlinklist[1].setlink(0,2,1);	
			atomlinklist[2].setlink(0,3,1);	
			atomlinklist[3].setlink(0,4,1);
		
			//		END CH4 MOLECULE
			break;

		case 1:
			//		BEGIN C2H4 MOLECULE


			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=600;

			init(6,5);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-173.2,0,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(173.2,0,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(46);
			atomlist[2].setoriginworldcoords(324,261.19,0);
			atomlist[2].currentatom = 1; // hydrogen

			atomlist[3].setaspseudosphere(46);
			atomlist[3].setoriginworldcoords(324,-261.19,0);
			atomlist[3].currentatom = 1; // hydrogen
		
			atomlist[4].setaspseudosphere(46);
			atomlist[4].setoriginworldcoords(-324,-261.19,0);
			atomlist[4].currentatom = 1; // hydrogen		

			atomlist[5].setaspseudosphere(46);
			atomlist[5].setoriginworldcoords(-324,261.19,0);
			atomlist[5].currentatom = 1; // hydrogen		

		
			atomlinklist[0].setlink(0,5,1);
			atomlinklist[1].setlink(0,4,1);	
			atomlinklist[2].setlink(0,1,2);	
			atomlinklist[3].setlink(1,2,1);
			atomlinklist[4].setlink(1,3,1);

		
			//		END C2H4 MOLECULE		   
			break;
			
		case 2:

			//		BEGIN C2H2 MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=800;

			init(4,3);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-166.7,0,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(166.7,0,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(46);
			atomlist[2].setoriginworldcoords(468.3,0,0);
			atomlist[2].currentatom = 1; // hydrogen

			atomlist[3].setaspseudosphere(46);
			atomlist[3].setoriginworldcoords(-468.3,0,0);
			atomlist[3].currentatom = 1; // hydrogen
					
			atomlinklist[0].setlink(0,1,3);
			atomlinklist[1].setlink(3,0,1);	
			atomlinklist[2].setlink(1,2,1);	


		
			//		END C2H2 MOLECULE	
				   
			break;		

		case 3:

			//		BEGIN C6H6 MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=1000;

			init(12,12);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-183.2,317.31,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(183.2,317.31,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(366.4,0,0);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(183.2,-317.31,0);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-183.2,-317.31,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-366.4,0,0);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(-334,578.5,0);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(334,578.5,0);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(46);
			atomlist[8].setoriginworldcoords(668,0,0);
			atomlist[8].currentatom = 1; // hydrogen

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(334,-578.5,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(-334,-578.5,0);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(46);
			atomlist[11].setoriginworldcoords(-668,0,0);
			atomlist[11].currentatom = 1; // hydrogen



			atomlinklist[0].setlink(0,1,2);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,2);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,2);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(1,7,1);	
			atomlinklist[8].setlink(2,8,1);	
			atomlinklist[9].setlink(3,9,1);
			atomlinklist[10].setlink(4,10,1);	
			atomlinklist[11].setlink(5,11,1);	

			//		END C6H6 MOLECULE	
				   
			break;		
		case 4:
			//		BEGIN C6H12 (BATEAU) MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=1000;

			init(18,18);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(183.2,0,298.29);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(355.41,212.77,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(183.2,0,-298.29);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(-183.2,0,-298.29);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-355.41,212.77,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-183.2,0,298.29);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(281.39,155.89,537.08);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(281.39,-285.17,298.29);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(46);
			atomlist[8].setoriginworldcoords(257.22,497.94,0);
			atomlist[8].currentatom = 1; // hydrogen

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(657.01,212.77,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(281.39,155.89,-537.08);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(46);
			atomlist[11].setoriginworldcoords(281.39,-285.17,-298.29);
			atomlist[11].currentatom = 1; // hydrogen


			atomlist[12].setaspseudosphere(46);
			atomlist[12].setoriginworldcoords(-281.39,155.89,537.08);
			atomlist[12].currentatom = 1; // hydrogen

			atomlist[13].setaspseudosphere(46);
			atomlist[13].setoriginworldcoords(-281.39,-285.17,298.29);
			atomlist[13].currentatom = 1; // hydrogen

			atomlist[14].setaspseudosphere(46);
			atomlist[14].setoriginworldcoords(-257.22,497.94,0);
			atomlist[14].currentatom = 1; // hydrogen

			atomlist[15].setaspseudosphere(46);
			atomlist[15].setoriginworldcoords(-657.01,212.77,0);
			atomlist[15].currentatom = 1; // hydrogen

			atomlist[16].setaspseudosphere(46);
			atomlist[16].setoriginworldcoords(-281.39,155.89,-537.08);
			atomlist[16].currentatom = 1; // hydrogen

			atomlist[17].setaspseudosphere(46);
			atomlist[17].setoriginworldcoords(-281.39,-285.17,-298.29);
			atomlist[17].currentatom = 1; // hydrogen
			



			atomlinklist[0].setlink(0,1,1);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,1);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,1);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(0,7,1);	
			atomlinklist[8].setlink(1,8,1);	
			atomlinklist[9].setlink(1,9,1);
			atomlinklist[10].setlink(2,10,1);	
			atomlinklist[11].setlink(2,11,1);	

			atomlinklist[12].setlink(5,12,1);
			atomlinklist[13].setlink(5,13,1);	
			atomlinklist[14].setlink(4,14,1);	
			atomlinklist[15].setlink(4,15,1);
			atomlinklist[16].setlink(3,16,1);	
			atomlinklist[17].setlink(3,17,1);	

			//		END C6H12 (BATEAU) MOLECULE			
		
			break;					
		case 5:
			//		BEGIN C6H12 (CHAISE) MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=1000;

			init(18,18);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(173.32,-59.37,298.29);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(405.18,86.12,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(173.32,-59.37,-298.29);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(-173.31,59.36,-298.29);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-405.18,-86.12,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-173.31,59.36,298.29);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(316.72,56.30,537.08);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(173.80,-360.97,298.29);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(46);
			atomlist[8].setoriginworldcoords(404.69,387.72,0);
			atomlist[8].currentatom = 1; // hydrogen

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(690.51,-11.61,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(319.72,56.30,-537.08);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(46);
			atomlist[11].setoriginworldcoords(173.80,-360.97,-298.29);
			atomlist[11].currentatom = 1; // hydrogen


			atomlist[12].setaspseudosphere(46);
			atomlist[12].setoriginworldcoords(-316.72,-56.30,537.08);
			atomlist[12].currentatom = 1; // hydrogen

			atomlist[13].setaspseudosphere(46);
			atomlist[13].setoriginworldcoords(-173.80,360.97,298.29);
			atomlist[13].currentatom = 1; // hydrogen

			atomlist[14].setaspseudosphere(46);
			atomlist[14].setoriginworldcoords(-404.70,-387.72,0);
			atomlist[14].currentatom = 1; // hydrogen

			atomlist[15].setaspseudosphere(46);
			atomlist[15].setoriginworldcoords(-690.51,11.61,0);
			atomlist[15].currentatom = 1; // hydrogen

			atomlist[16].setaspseudosphere(46);
			atomlist[16].setoriginworldcoords(-316.72,-56.30,-537.08);
			atomlist[16].currentatom = 1; // hydrogen

			atomlist[17].setaspseudosphere(46);
			atomlist[17].setoriginworldcoords(-173.80,360.97,-298.29);
			atomlist[17].currentatom = 1; // hydrogen
			
			



			atomlinklist[0].setlink(0,1,1);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,1);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,1);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(0,7,1);	
			atomlinklist[8].setlink(1,8,1);	
			atomlinklist[9].setlink(1,9,1);
			atomlinklist[10].setlink(2,10,1);	
			atomlinklist[11].setlink(2,11,1);	

			atomlinklist[12].setlink(5,12,1);
			atomlinklist[13].setlink(5,13,1);	
			atomlinklist[14].setlink(4,14,1);	
			atomlinklist[15].setlink(4,15,1);
			atomlinklist[16].setlink(3,16,1);	
			atomlinklist[17].setlink(3,17,1);	

			//		END C6H12 (CHAISE) MOLECULE			

			break;					

		case 6:
			//		BEGIN NH2-R-SO2-NH2 MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=1500;

			init(21,22);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-183.2,317.31,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(183.2,317.31,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(366.4,0,0);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(183.2,-317.31,0);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-183.2,-317.31,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-366.4,0,0);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(-334,578.5,0);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(334,578.5,0);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(144);
			atomlist[8].setoriginworldcoords(738.3,0,0);
			atomlist[8].currentatom = 16; // sulfur

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(334,-578.5,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(-334,-578.5,0);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(97);
			atomlist[11].setoriginworldcoords(-690.8,0,0);
			atomlist[11].currentatom = 7; // nitrogen


			atomlist[12].setaspseudosphere(91);
			atomlist[12].setoriginworldcoords(909.74,296.96,135.52);
			atomlist[12].currentatom = 8; // oxygen

			atomlist[13].setaspseudosphere(91);
			atomlist[13].setoriginworldcoords(909.74,-296.96,135.52);
			atomlist[13].currentatom = 8; // oxygen

			atomlist[14].setaspseudosphere(46);
			atomlist[14].setoriginworldcoords(1002.42,235.18,-479.94);
			atomlist[14].currentatom = 1; // hydrogen

			atomlist[15].setaspseudosphere(46);
			atomlist[15].setoriginworldcoords(1002.42,-235.18,-479.94);
			atomlist[15].currentatom = 1; // hydrogen

			atomlist[16].setaspseudosphere(10);
			atomlist[16].setoriginworldcoords(782.64,0,-438.35);
			atomlist[16].currentatom = 500; // free electrons

			atomlist[17].setaspseudosphere(46);
			atomlist[17].setoriginworldcoords(-826.94,235.18,106.87);
			atomlist[17].currentatom = 1; // hydrogen
			
			atomlist[18].setaspseudosphere(46);
			atomlist[18].setoriginworldcoords(-826.94,-235.18,106.87);
			atomlist[18].currentatom = 1; // hydrogen

			atomlist[19].setaspseudosphere(10);
			atomlist[19].setoriginworldcoords(-725.51,0,-100.79);
			atomlist[19].currentatom = 500; // free electrons

			atomlist[20].setaspseudosphere(97);
			atomlist[20].setoriginworldcoords(866.64,0,-372.72);
			atomlist[20].currentatom = 7; // nitrogen
			


			atomlinklist[0].setlink(0,1,2);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,2);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,2);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(1,7,1);	
			atomlinklist[8].setlink(2,8,1);	
			atomlinklist[9].setlink(3,9,1);
			atomlinklist[10].setlink(4,10,1);	
			atomlinklist[11].setlink(5,11,1);	

			atomlinklist[12].setlink(8,12,2);
			atomlinklist[13].setlink(8,13,2);	
			atomlinklist[14].setlink(8,20,1);	
			atomlinklist[15].setlink(20,15,1);
			atomlinklist[16].setlink(20,14,1);	
			atomlinklist[17].setlink(20,16,1);	

			atomlinklist[18].setlink(5,11,1);	
			atomlinklist[19].setlink(11,18,1);
			atomlinklist[20].setlink(11,17,1);	
			atomlinklist[21].setlink(11,19,1);	
			
			//		END NH2-R-SO2-NH2 MOLECULE

			break;	
			
		case 7:
			//		BEGIN NH2-R-CO-CH2-CH3 MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=1500;

			init(23,23);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-183.2,317.31,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(183.2,317.31,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(366.4,0,0);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(183.2,-317.31,0);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-183.2,-317.31,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-366.4,0,0);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(-334,578.5,0);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(334,578.5,0);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(118);
			atomlist[8].setoriginworldcoords(732.8,0,0);
			atomlist[8].currentatom = 6; // carbon

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(334,-578.5,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(-334,-578.5,0);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(97);
			atomlist[11].setoriginworldcoords(-690.8,0,0);
			atomlist[11].currentatom = 7; // nitrogen


			atomlist[12].setaspseudosphere(91);
			atomlist[12].setoriginworldcoords(898.4,0,-286.83);
			atomlist[12].currentatom = 8; // oxygen

			atomlist[13].setaspseudosphere(118);
			atomlist[13].setoriginworldcoords(1081.6,0,317.3);
			atomlist[13].currentatom = 6; // carbon

			atomlist[14].setaspseudosphere(46);
			atomlist[14].setoriginworldcoords(983.4,274,396.3);
			atomlist[14].currentatom = 1; // hydrogen

			atomlist[15].setaspseudosphere(46);
			atomlist[15].setoriginworldcoords(983.4,-274,396.3);
			atomlist[15].currentatom = 1; // hydrogen

			atomlist[16].setaspseudosphere(118);
			atomlist[16].setoriginworldcoords(1448,0,317.3);
			atomlist[16].currentatom = 6; // carbon

			atomlist[17].setaspseudosphere(46);
			atomlist[17].setoriginworldcoords(1546.2,0,32.1);
			atomlist[17].currentatom = 1; // hydrogen

			atomlist[18].setaspseudosphere(46);
			atomlist[18].setoriginworldcoords(1546.2,274,396.3);
			atomlist[18].currentatom = 1; // hydrogen
			
			atomlist[19].setaspseudosphere(46);
			atomlist[19].setoriginworldcoords(1546.2,-274,396.3);
			atomlist[19].currentatom = 1; // hydrogen
			
			atomlist[20].setaspseudosphere(46);
			atomlist[20].setoriginworldcoords(-826.94,235.18,106.87);
			atomlist[20].currentatom = 1; // hydrogen
			
			atomlist[21].setaspseudosphere(46);
			atomlist[21].setoriginworldcoords(-826.94,-235.18,106.87);
			atomlist[21].currentatom = 1; // hydrogen
			
			atomlist[22].setaspseudosphere(10);
			atomlist[22].setoriginworldcoords(-725.51,0,-100.79);
			atomlist[22].currentatom = 500; // free electrons

			atomlinklist[0].setlink(0,1,2);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,2);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,2);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(1,7,1);	
			atomlinklist[8].setlink(2,8,1);	
			atomlinklist[9].setlink(3,9,1);
			atomlinklist[10].setlink(4,10,1);	
			atomlinklist[11].setlink(5,11,1);	

			atomlinklist[12].setlink(8,12,2);
			atomlinklist[13].setlink(8,13,1);	
			atomlinklist[14].setlink(13,14,1);	
			atomlinklist[15].setlink(13,15,1);
			atomlinklist[16].setlink(13,16,1);	
			atomlinklist[17].setlink(16,17,1);	

			atomlinklist[18].setlink(16,18,1);	
			atomlinklist[19].setlink(16,19,1);
			atomlinklist[20].setlink(11,20,1);	
			atomlinklist[21].setlink(11,21,1);			
			atomlinklist[22].setlink(11,22,1);
			
			//		END NH2-R-CO-CH2-CH3 MOLECULE

			break;	


		case 8:
			//		BEGIN NH2-R-CO-O-CH2-CH3 MOLECULE
					
			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=2000;
			
			init(24,24);
		
			atomlist[0].setaspseudosphere(118);
			atomlist[0].setoriginworldcoords(-183.2,317.31,0);
			atomlist[0].currentatom = 6; // carbon

			atomlist[1].setaspseudosphere(118);
			atomlist[1].setoriginworldcoords(183.2,317.31,0);
			atomlist[1].currentatom = 6; // carbon
		
			atomlist[2].setaspseudosphere(118);
			atomlist[2].setoriginworldcoords(366.4,0,0);
			atomlist[2].currentatom = 6; // carbon

			atomlist[3].setaspseudosphere(118);
			atomlist[3].setoriginworldcoords(183.2,-317.31,0);
			atomlist[3].currentatom = 6; // carbon
					
			atomlist[4].setaspseudosphere(118);
			atomlist[4].setoriginworldcoords(-183.2,-317.31,0);
			atomlist[4].currentatom = 6; // carbon

			atomlist[5].setaspseudosphere(118);
			atomlist[5].setoriginworldcoords(-366.4,0,0);
			atomlist[5].currentatom = 6; // carbon


			atomlist[6].setaspseudosphere(46);
			atomlist[6].setoriginworldcoords(-334,578.5,0);
			atomlist[6].currentatom = 1; // hydrogen

			atomlist[7].setaspseudosphere(46);
			atomlist[7].setoriginworldcoords(334,578.5,0);
			atomlist[7].currentatom = 1; // hydrogen

			atomlist[8].setaspseudosphere(118);
			atomlist[8].setoriginworldcoords(732.8,0,0);
			atomlist[8].currentatom = 6; // carbon

			atomlist[9].setaspseudosphere(46);
			atomlist[9].setoriginworldcoords(334,-578.5,0);
			atomlist[9].currentatom = 1; // hydrogen

			atomlist[10].setaspseudosphere(46);
			atomlist[10].setoriginworldcoords(-334,-578.5,0);
			atomlist[10].currentatom = 1; // hydrogen

			atomlist[11].setaspseudosphere(97);
			atomlist[11].setoriginworldcoords(-690.8,0,0);
			atomlist[11].currentatom = 7; // nitrogen


			atomlist[12].setaspseudosphere(91);
			atomlist[12].setoriginworldcoords(898.4,0,286.83);
			atomlist[12].currentatom = 8; // oxygen

			atomlist[13].setaspseudosphere(91);
			atomlist[13].setoriginworldcoords(1012.7,0,-332.1);
			atomlist[13].currentatom = 8; // oxygen

			atomlist[14].setaspseudosphere(118);
			atomlist[14].setoriginworldcoords(1362.8,0,-304.5);
			atomlist[14].currentatom = 6; // carbon

			atomlist[15].setaspseudosphere(46);
			atomlist[15].setoriginworldcoords(1416.8,274,-188.8);
			atomlist[15].currentatom = 1; // hydrogen

			atomlist[16].setaspseudosphere(46);
			atomlist[16].setoriginworldcoords(1416.8,-274,-188.8);
			atomlist[16].currentatom = 1; // hydrogen

			atomlist[17].setaspseudosphere(118);
			atomlist[17].setoriginworldcoords(1482.1,0,-650.9);
			atomlist[17].currentatom = 6; // carbon

			atomlist[18].setaspseudosphere(46);
			atomlist[18].setoriginworldcoords(1244.4,0,-836.6);
			atomlist[18].currentatom = 1; // hydrogen
			
			atomlist[19].setaspseudosphere(46);
			atomlist[19].setoriginworldcoords(1608.1,274,-650.90);
			atomlist[19].currentatom = 1; // hydrogen
			
			atomlist[20].setaspseudosphere(46);
			atomlist[20].setoriginworldcoords(-826.94,235.18,106.87);
			atomlist[20].currentatom = 1; // hydrogen
			
			atomlist[21].setaspseudosphere(46);
			atomlist[21].setoriginworldcoords(-826.94,-235.18,106.87);
			atomlist[21].currentatom = 1; // hydrogen
			
			atomlist[22].setaspseudosphere(46);
			atomlist[22].setoriginworldcoords(1608.1,-274,-650.9);
			atomlist[22].currentatom = 1; // hydrogen

			atomlist[23].setaspseudosphere(10);
			atomlist[23].setoriginworldcoords(-725.51,0,-100.79);
			atomlist[23].currentatom = 500; // free electrons

			atomlinklist[0].setlink(0,1,2);
			atomlinklist[1].setlink(1,2,1);	
			atomlinklist[2].setlink(2,3,2);	
			atomlinklist[3].setlink(3,4,1);
			atomlinklist[4].setlink(4,5,2);	
			atomlinklist[5].setlink(5,0,1);	

			atomlinklist[6].setlink(0,6,1);
			atomlinklist[7].setlink(1,7,1);	
			atomlinklist[8].setlink(2,8,1);	
			atomlinklist[9].setlink(3,9,1);

			atomlinklist[10].setlink(4,10,1);	
			atomlinklist[11].setlink(5,11,1);	

			atomlinklist[12].setlink(8,12,2);
			atomlinklist[13].setlink(8,13,1);	
			atomlinklist[14].setlink(13,14,1);	
			atomlinklist[15].setlink(14,15,1);
			atomlinklist[16].setlink(14,16,1);	
			atomlinklist[17].setlink(14,17,1);	

			atomlinklist[18].setlink(17,18,1);	
			atomlinklist[19].setlink(17,19,1);
			atomlinklist[20].setlink(17,22,1);	
			atomlinklist[21].setlink(11,20,1);			
			atomlinklist[22].setlink(11,21,1);			
			atomlinklist[23].setlink(11,23,1);
			//		END NH2-R-CO-O-CH2-CH3

			break;	




		case 9:

			//    BEGIN TEXT (MICHEL AIME LA CHIMIE)


			// we need to define the fixfactor here because we don't want the molecule to hit the viewer
			ZFIXFACTOR=700;
					
			init(21,0);
						
			atomlist[0].setasprofchimie(5);
			atomlist[0].setoriginworldcoords(0,0,500);
			atomlist[0].currentatom = 1; // yellow


			atomlist[1].setasletter(13,18);
			atomlist[1].setoriginworldcoords(-500,450,-200);
			atomlist[1].currentatom = 6; // blue

			atomlist[2].setasletter(9,16);
			atomlist[2].setoriginworldcoords(-300,450,-100);
			atomlist[2].currentatom = 6; // blue

			atomlist[3].setasletter(3,16);
			atomlist[3].setoriginworldcoords(-100,450,0);
			atomlist[3].currentatom = 6; // blue

			atomlist[4].setasletter(8,16);
			atomlist[4].setoriginworldcoords(100,450,100);
			atomlist[4].currentatom = 6; // blue
			
			atomlist[5].setasletter(5,16);
			atomlist[5].setoriginworldcoords(300,450,200);
			atomlist[5].currentatom = 6; // blue

			atomlist[6].setasletter(12,16);
			atomlist[6].setoriginworldcoords(500,450,300);
			atomlist[6].currentatom = 6; // blue

			atomlist[7].setasletter(1,10);
			atomlist[7].setoriginworldcoords(-300,150,0);
			atomlist[7].currentatom = 8; // blue			

			atomlist[8].setasletter(9,10);
			atomlist[8].setoriginworldcoords(-100,150,0);
			atomlist[8].currentatom = 8; // blue			

			atomlist[9].setasletter(13,10);
			atomlist[9].setoriginworldcoords(100,150,0);
			atomlist[9].currentatom = 8; // blue			

			atomlist[10].setasletter(5,10);
			atomlist[10].setoriginworldcoords(300,150,0);
			atomlist[10].currentatom = 8; // blue			


			atomlist[11].setasletter(12,10);
			atomlist[11].setoriginworldcoords(-100,-150,0);
			atomlist[11].currentatom = 7; // blue			

			atomlist[12].setasletter(1,10);
			atomlist[12].setoriginworldcoords(100,-150,0);
			atomlist[12].currentatom = 7; // blue			
			

			atomlist[13].setasletter(3,16);
			atomlist[13].setoriginworldcoords(-500,-450,300);
			atomlist[13].currentatom = 16; // blue			

			atomlist[14].setasletter(8,16);
			atomlist[14].setoriginworldcoords(-300,-450,200);
			atomlist[14].currentatom = 16; // blue			

			atomlist[15].setasletter(9,16);
			atomlist[15].setoriginworldcoords(-100,-450,100);
			atomlist[15].currentatom = 16; // blue			

			atomlist[16].setasletter(13,16);
			atomlist[16].setoriginworldcoords(100,-450,0);
			atomlist[16].currentatom = 16; // blue			

			atomlist[17].setasletter(9,16);
			atomlist[17].setoriginworldcoords(300,-450,-100);
			atomlist[17].currentatom = 16; // blue			

			atomlist[18].setasletter(5,16);
			atomlist[18].setoriginworldcoords(500,-450,-200);
			atomlist[18].currentatom = 16; // blue			


			atomlist[19].setasprofchimie(5);
			atomlist[19].setoriginworldcoords(-700,0,0);
			atomlist[19].currentatom = 1; // yellow


			atomlist[20].setasprofchimie(5);
			atomlist[20].setoriginworldcoords(700,0,0);
			atomlist[20].currentatom = 1; // yellow


			//		END TEXT
			break;

			
		}


}


