// shape class

// should make functions that convert a single point from world->aligned, erasing the double coding for the origin
// same for aligned->screen

// draw functions is limited to 4 points, could change.



class shape3D
{
	public:
		// variables
		point_3D * locallist;
		point_3D * worldlist;
		point_3D * alignedlist;
		point_2D * screenlist;
		
		point_3D originworldcoords;
		point_3D originalignedcoords;
		point_2D originscreencoords;
		
		face * facelist;
		int nbofptsinshape, nboffacesinshape;
		int currentshapetype, currentatom, scaling;
		int locallistdeleted;
		
		// rotation values
		float rx, ry, rz;




		// functions		
		shape3D(void) { nbofptsinshape=0; nboffacesinshape=0; rx=0; ry=0; rz=0; scaling=1; currentshapetype=0; currentatom=0; locallistdeleted=0;}
		~shape3D(void) { setasnothing(); }

		// for debugging: prints (in text) the coords for every list		
		void printlocallist();
		void printworldlist();
		void printalignedlist();
		void printscreenlist();
		void printfaces();
		
		// generate coordinates
		inline void generateworldcoords();
		inline void generatealignedcoords();
		inline void generatescreencoords();
		inline void generateallcoords();
		
		// generate origin coordinates
		inline void generatealignedorigincoords();
		inline void generatescreenorigincoords();
		inline void generatealignedpointcoords();
		inline void generatescreenpointcoords();

		// set origin
		inline void setoriginworldcoords(point_3D tmp) { originworldcoords.setcoords(tmp.x, tmp.y, tmp.z); }
		inline void setoriginworldcoords(int x, int y, int z) { originworldcoords.setcoords(x, y, z); }

		// adjust rotations
		inline void setallrotations(float x, float y, float z) { rx+=(x*45); ry+=(y*45); rz+=(z*45); }
		
		// what shape is it ?
		void setascube(int side);
		void setaspseudosphere(void);
		void setaspseudosphere(int factor);
		void setasprofchimie(int factor);
		void setasprofchimie(void);
		void setasletter(int letter);
		void setasletter(int letter, int factor);
		void setasnothing(void);


		void displayshape(BITMAP *bitmap);

};

// used for debugging
void shape3D::printlocallist()
{
	int i;
	for(i = 0; i<nbofptsinshape;i++)
	{
		cout << "localist[" << i << "] = (" << this->locallist[i].x << ", " << this->locallist[i].y << ", " << this->locallist[i].z << ")\n";
	}
	return;
}

// used for debugging
void shape3D::printworldlist()
{
	int i;
	for(i = 0; i<nbofptsinshape;i++)
	{
		cout << "worldlist[" << i << "] = (" << this->worldlist[i].x << ", " << this->worldlist[i].y << ", " << this->worldlist[i].z << ")\n";
	}
	return;
}

// used for debugging
void shape3D::printalignedlist()
{
	int i;
	for(i = 0; i<nbofptsinshape;i++)
	{
		cout << "alignedlist[" << i << "] = (" << this->alignedlist[i].x << ", " << this->alignedlist[i].y << ", " << this->alignedlist[i].z << ")\n";
	}
	return;
}

// used for debugging
void shape3D::printscreenlist()
{
	int i;
	for(i = 0; i<nbofptsinshape;i++)
	{
		cout << "screenlist[" << i << "] = (" << this->screenlist[i].x << ", " << this->screenlist[i].y << ")\n";
	}
	return;
}

// used for debugging
void shape3D::printfaces()
{
	int i, j;
	
	for (i=0; i<nboffacesinshape;i++)
	{
		cout << "facelist[" << i << "]: " << endl;
		
		for (j=0;j<facelist[i].nbofptsinface;j++)
		{
			cout << facelist[i].points[j] << "->";
		}
		
		cout << endl;
	}
	
}






// local -> world
inline void shape3D::generateworldcoords()
{
	int i;

	for (i=0;i<nbofptsinshape;i++)
		{
		worldlist[i].x=scaling*locallist[i].x+originworldcoords.x;
		worldlist[i].y=scaling*locallist[i].y+originworldcoords.y;
		worldlist[i].z=scaling*locallist[i].z+originworldcoords.z;
		}

	// no code to transform origin because there is no localorigin

}






// world -> aligned
inline void shape3D::generatealignedcoords()
{
	generatealignedpointcoords();
	generatealignedorigincoords();
				
}

// world (origin) -> aligned(origin)
inline void shape3D::generatealignedorigincoords()
{
	point_3D tmp;


	// move center of object
	// around x-axis
	tmp.x=originworldcoords.x;
	tmp.y=originworldcoords.y;
	tmp.z=originworldcoords.z;
	
	originalignedcoords.x=tmp.x;
	originalignedcoords.y=(tmp.y * COS(rx)) + (tmp.z * SIN(rx));
	originalignedcoords.z=(-tmp.y * SIN(rx)) + (tmp.z * COS(rx));
	
	// around y-axis
	tmp.x=originalignedcoords.x;
	tmp.y=originalignedcoords.y;
	tmp.z=originalignedcoords.z;	

	originalignedcoords.x=tmp.x * COS(ry) - (tmp.z * SIN(ry));
	originalignedcoords.y=tmp.y;
	originalignedcoords.z=(tmp.x * SIN(ry)) + tmp.z * COS(ry);
	
	// around z-axis
	tmp.x=originalignedcoords.x;
	tmp.y=originalignedcoords.y;
	tmp.z=originalignedcoords.z;	

	originalignedcoords.x=tmp.x * COS(rz) - tmp.y * SIN(rz);
	originalignedcoords.y=(tmp.x * SIN(rz)) + tmp.y * COS(rz);
	originalignedcoords.z= tmp.z;	

	// originally: correction factor -> projects further on screen.
	// now: move the atom without making it spin away from it's center
	originalignedcoords.x+=XFIXFACTOR;
	originalignedcoords.y+=YFIXFACTOR;
	originalignedcoords.z+=ZFIXFACTOR;

}


// world (all coords) -> aligned(allcoords)
inline void shape3D::generatealignedpointcoords()
{
	int i;
	point_3D tmp;

	
	for (i=0;i<nbofptsinshape;i++)
		{
		tmp.x=worldlist[i].x;
		tmp.y=worldlist[i].y;
		tmp.z=worldlist[i].z;	

	
		//around x-axis
		alignedlist[i].x= tmp.x;
		alignedlist[i].y= tmp.y * COS(rx) + tmp.z * SIN(rx);
		alignedlist[i].z=-tmp.y * SIN(rx) + tmp.z * COS(rx);


		tmp.x=alignedlist[i].x;
		tmp.y=alignedlist[i].y;
		tmp.z=alignedlist[i].z;
		
		//around y-axis
		alignedlist[i].x= tmp.x * COS(ry) - (tmp.z * SIN(ry));
		alignedlist[i].y= tmp.y;
		alignedlist[i].z=(tmp.x * SIN(ry)) + tmp.z * COS(ry);


		tmp.x=alignedlist[i].x;
		tmp.y=alignedlist[i].y;
		tmp.z=alignedlist[i].z;

		// around z-axis
		alignedlist[i].x= tmp.x * COS(rz) - tmp.y * SIN(rz);
		alignedlist[i].y=(tmp.x * SIN(rz)) + tmp.y * COS(rz);
		alignedlist[i].z= tmp.z;

		
		// originally: correction factor -> projects further on screen.
		// now: move the atom without making it spin away from it's center
		alignedlist[i].x=alignedlist[i].x+XFIXFACTOR;
		alignedlist[i].y=alignedlist[i].y+YFIXFACTOR;
		alignedlist[i].z=alignedlist[i].z+ZFIXFACTOR;

		
		}
			

}








// aligned -> screen
inline void shape3D::generatescreencoords()
{
	generatescreenpointcoords();
	generatescreenorigincoords();

}

// aligned (all points) -> screen (all points)
inline void shape3D::generatescreenpointcoords()
{

	int i;

	
	for (i=0;i<nbofptsinshape;i++)
		{

			
		// prevent divide by zero
		if (alignedlist[i].z==0) 
			{
			screenlist[i].x = alignedlist[i].x * FOCALDISTANCE  +SCREEN_WIDTH/2;
			screenlist[i].y = alignedlist[i].y * -FOCALDISTANCE +SCREEN_HEIGHT/2;
			}
		else
			{
			screenlist[i].x = (alignedlist[i].x * FOCALDISTANCE ) / alignedlist[i].z +SCREEN_WIDTH/2;
			screenlist[i].y = (alignedlist[i].y * -FOCALDISTANCE ) / alignedlist[i].z +SCREEN_HEIGHT/2;
			}
		
		}
}


// aligned (origin) -> screen (origin)
inline void shape3D::generatescreenorigincoords()
{

	// prevent divide by zero
	if (originalignedcoords.z==0)
		{
		originscreencoords.x = originalignedcoords.x * FOCALDISTANCE + SCREEN_WIDTH/2;
		originscreencoords.y = originalignedcoords.y * -FOCALDISTANCE + SCREEN_WIDTH/2;
		}
	else
		{
		originscreencoords.x = (originalignedcoords.x * FOCALDISTANCE) / originalignedcoords.z + SCREEN_WIDTH/2;
		originscreencoords.y = (originalignedcoords.y * -FOCALDISTANCE) / originalignedcoords.z  + SCREEN_HEIGHT/2;
		}
}






// shortens coding time by making less function calls
inline void shape3D::generateallcoords(void)
{
	generateworldcoords();
	generatealignedcoords();
	generatescreencoords();
}















// because sometimes cubes aren't as much fun as spheres.
void shape3D::setaspseudosphere(void)		
{
	int tmpintarray[3] = {0,0,0};
	
	// no checking to see if it is already a type

	// defines
	nbofptsinshape = 38;
	nboffacesinshape = 79;
	currentshapetype=1;	
	
	facelist = new face[nboffacesinshape];
	locallist = new point_3D[nbofptsinshape];
	worldlist = new point_3D[nbofptsinshape];
	alignedlist = new point_3D[nbofptsinshape];
	screenlist = new point_2D[nbofptsinshape];



	// all the points
	locallist[0].setcoords(0,PSEUDOSPHERE_MAX,0);
	
	locallist[1].setcoords(-PSEUDOSPHERE_A2,PSEUDOSPHERE_A,0);
	locallist[2].setcoords(0,PSEUDOSPHERE_A,PSEUDOSPHERE_A2);
	locallist[3].setcoords(PSEUDOSPHERE_A2,PSEUDOSPHERE_A,0);
	locallist[4].setcoords(0,PSEUDOSPHERE_A,-PSEUDOSPHERE_A2);

	locallist[5].setcoords(-PSEUDOSPHERE_A,PSEUDOSPHERE_A2,0);
	locallist[6].setcoords(-PSEUDOSPHERE_A2,PSEUDOSPHERE_A2,PSEUDOSPHERE_A2);
	locallist[7].setcoords(0,PSEUDOSPHERE_A2,PSEUDOSPHERE_A);
	locallist[8].setcoords(PSEUDOSPHERE_A2,PSEUDOSPHERE_A2,PSEUDOSPHERE_A2);
	locallist[9].setcoords(PSEUDOSPHERE_A,PSEUDOSPHERE_A2,0);
	locallist[10].setcoords(PSEUDOSPHERE_A2,PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2);
	locallist[11].setcoords(0,PSEUDOSPHERE_A2,-PSEUDOSPHERE_A);
	locallist[12].setcoords(-PSEUDOSPHERE_A2,PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2);
	

	locallist[13].setcoords(-PSEUDOSPHERE_MAX,0,0);
	locallist[14].setcoords(-PSEUDOSPHERE_A,0,PSEUDOSPHERE_A2);
	locallist[15].setcoords(-PSEUDOSPHERE_A2,0,PSEUDOSPHERE_A);
	locallist[16].setcoords(0,0,PSEUDOSPHERE_MAX);
	locallist[17].setcoords(PSEUDOSPHERE_A2,0,PSEUDOSPHERE_A);
	locallist[18].setcoords(PSEUDOSPHERE_A,0,PSEUDOSPHERE_A2);
	locallist[19].setcoords(PSEUDOSPHERE_MAX,0,0);
	locallist[20].setcoords(PSEUDOSPHERE_A,0,-PSEUDOSPHERE_A2);
	locallist[21].setcoords(PSEUDOSPHERE_A2,0,-PSEUDOSPHERE_A);
	locallist[22].setcoords(0,0,-PSEUDOSPHERE_MAX);
	locallist[23].setcoords(-PSEUDOSPHERE_A2,0,-PSEUDOSPHERE_A);
	locallist[24].setcoords(-PSEUDOSPHERE_A,0,-PSEUDOSPHERE_A2);
	
	locallist[25].setcoords(-PSEUDOSPHERE_A,-PSEUDOSPHERE_A2,0);
	locallist[26].setcoords(-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2,PSEUDOSPHERE_A2);
	locallist[27].setcoords(0,-PSEUDOSPHERE_A2,PSEUDOSPHERE_A);
	locallist[28].setcoords(PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2,PSEUDOSPHERE_A2);
	locallist[29].setcoords(PSEUDOSPHERE_A,-PSEUDOSPHERE_A2,0);
	locallist[30].setcoords(PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2);
	locallist[31].setcoords(0,-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A);
	locallist[32].setcoords(-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A2);
	
	locallist[33].setcoords(-PSEUDOSPHERE_A2,-PSEUDOSPHERE_A,0);
	locallist[34].setcoords(0,-PSEUDOSPHERE_A,PSEUDOSPHERE_A2);
	locallist[35].setcoords(PSEUDOSPHERE_A2,-PSEUDOSPHERE_A,0);
	locallist[36].setcoords(0,-PSEUDOSPHERE_A,-PSEUDOSPHERE_A2);
	
	locallist[37].setcoords(0,-PSEUDOSPHERE_MAX,0);
	
	// all the faces
	tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2;		facelist[0].set(3, tmpintarray );
	tmpintarray[0]=0; tmpintarray[1]=2; tmpintarray[2]=3;		facelist[1].set(3, tmpintarray );
	tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=4;		facelist[2].set(3, tmpintarray );
	tmpintarray[0]=0; tmpintarray[1]=4; tmpintarray[2]=1;		facelist[3].set(3, tmpintarray );
	
	tmpintarray[0]=1; tmpintarray[1]=5; tmpintarray[2]=6;		facelist[4].set(3, tmpintarray );
	tmpintarray[0]=1; tmpintarray[1]=6; tmpintarray[2]=7;		facelist[5].set(3, tmpintarray );
	tmpintarray[0]=1; tmpintarray[1]=7; tmpintarray[2]=2;		facelist[6].set(3, tmpintarray );
	tmpintarray[0]=2; tmpintarray[1]=7; tmpintarray[2]=8;		facelist[7].set(3, tmpintarray );
	tmpintarray[0]=2; tmpintarray[1]=8; tmpintarray[2]=9;		facelist[8].set(3, tmpintarray );
	tmpintarray[0]=2; tmpintarray[1]=9; tmpintarray[2]=3;		facelist[9].set(3, tmpintarray );
	tmpintarray[0]=3; tmpintarray[1]=9; tmpintarray[2]=10;		facelist[10].set(3, tmpintarray );
	tmpintarray[0]=3; tmpintarray[1]=10; tmpintarray[2]=11;		facelist[11].set(3, tmpintarray );
	tmpintarray[0]=3; tmpintarray[1]=11; tmpintarray[2]=4;		facelist[12].set(3, tmpintarray );
	tmpintarray[0]=4; tmpintarray[1]=11; tmpintarray[2]=12;		facelist[13].set(3, tmpintarray );
	tmpintarray[0]=4; tmpintarray[1]=12; tmpintarray[2]=5;		facelist[14].set(3, tmpintarray );
	tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=1;		facelist[15].set(3, tmpintarray );
	
	tmpintarray[0]=5; tmpintarray[1]=13; tmpintarray[2]=14;		facelist[16].set(3, tmpintarray );
	tmpintarray[0]=5; tmpintarray[1]=14; tmpintarray[2]=6;		facelist[17].set(3, tmpintarray );
	tmpintarray[0]=6; tmpintarray[1]=14; tmpintarray[2]=15;		facelist[18].set(3, tmpintarray );
	tmpintarray[0]=6; tmpintarray[1]=15; tmpintarray[2]=16;		facelist[19].set(3, tmpintarray );
	tmpintarray[0]=6; tmpintarray[1]=15; tmpintarray[2]=7;		facelist[20].set(3, tmpintarray );
	tmpintarray[0]=7; tmpintarray[1]=15; tmpintarray[2]=16;		facelist[21].set(3, tmpintarray );
	tmpintarray[0]=7; tmpintarray[1]=16; tmpintarray[2]=17;		facelist[22].set(3, tmpintarray );
	tmpintarray[0]=7; tmpintarray[1]=17; tmpintarray[2]=8;		facelist[23].set(3, tmpintarray );
	tmpintarray[0]=8; tmpintarray[1]=17; tmpintarray[2]=18;		facelist[24].set(3, tmpintarray );
	tmpintarray[0]=8; tmpintarray[1]=18; tmpintarray[2]=19;		facelist[25].set(3, tmpintarray );
	tmpintarray[0]=8; tmpintarray[1]=18; tmpintarray[2]=9;		facelist[26].set(3, tmpintarray );
	tmpintarray[0]=9; tmpintarray[1]=18; tmpintarray[2]=19;		facelist[27].set(3, tmpintarray );
	tmpintarray[0]=9; tmpintarray[1]=19; tmpintarray[2]=20;		facelist[28].set(3, tmpintarray );
	tmpintarray[0]=9; tmpintarray[1]=20; tmpintarray[2]=10;		facelist[29].set(3, tmpintarray );
	tmpintarray[0]=10; tmpintarray[1]=20; tmpintarray[2]=21;	facelist[30].set(3, tmpintarray );
	tmpintarray[0]=10; tmpintarray[1]=21; tmpintarray[2]=22;	facelist[31].set(3, tmpintarray );
	tmpintarray[0]=10; tmpintarray[1]=21; tmpintarray[2]=11;	facelist[32].set(3, tmpintarray );
	tmpintarray[0]=11; tmpintarray[1]=21; tmpintarray[2]=22;	facelist[33].set(3, tmpintarray );
	tmpintarray[0]=11; tmpintarray[1]=22; tmpintarray[2]=23;	facelist[34].set(3, tmpintarray );
	tmpintarray[0]=11; tmpintarray[1]=23; tmpintarray[2]=12;	facelist[35].set(3, tmpintarray );
	tmpintarray[0]=12; tmpintarray[1]=23; tmpintarray[2]=24;	facelist[36].set(3, tmpintarray );
	tmpintarray[0]=12; tmpintarray[1]=24; tmpintarray[2]=13;	facelist[37].set(3, tmpintarray );
	tmpintarray[0]=12; tmpintarray[1]=13; tmpintarray[2]=5;		facelist[38].set(3, tmpintarray );
	
	
	tmpintarray[0]=25; tmpintarray[1]=14; tmpintarray[2]=13;	facelist[39].set(3, tmpintarray );
	tmpintarray[0]=25; tmpintarray[1]=13; tmpintarray[2]=24;	facelist[40].set(3, tmpintarray );
	tmpintarray[0]=26; tmpintarray[1]=15; tmpintarray[2]=14;	facelist[41].set(3, tmpintarray );
	tmpintarray[0]=26; tmpintarray[1]=16; tmpintarray[2]=15;	facelist[42].set(3, tmpintarray );
	tmpintarray[0]=26; tmpintarray[1]=27; tmpintarray[2]=16;	facelist[43].set(3, tmpintarray );
	tmpintarray[0]=27; tmpintarray[1]=16; tmpintarray[2]=15;	facelist[44].set(3, tmpintarray );
	tmpintarray[0]=27; tmpintarray[1]=17; tmpintarray[2]=16;	facelist[45].set(3, tmpintarray );
	tmpintarray[0]=27; tmpintarray[1]=28; tmpintarray[2]=17;	facelist[46].set(3, tmpintarray );
	tmpintarray[0]=28; tmpintarray[1]=18; tmpintarray[2]=17;	facelist[47].set(3, tmpintarray );
	tmpintarray[0]=28; tmpintarray[1]=19; tmpintarray[2]=18;	facelist[48].set(3, tmpintarray );
	tmpintarray[0]=28; tmpintarray[1]=29; tmpintarray[2]=19;	facelist[49].set(3, tmpintarray );
	tmpintarray[0]=29; tmpintarray[1]=19; tmpintarray[2]=18;	facelist[50].set(3, tmpintarray );
	tmpintarray[0]=29; tmpintarray[1]=20; tmpintarray[2]=19;	facelist[51].set(3, tmpintarray );
	tmpintarray[0]=29; tmpintarray[1]=30; tmpintarray[2]=20;	facelist[52].set(3, tmpintarray );
	tmpintarray[0]=30; tmpintarray[1]=21; tmpintarray[2]=20;	facelist[53].set(3, tmpintarray );
	tmpintarray[0]=30; tmpintarray[1]=22; tmpintarray[2]=21;	facelist[54].set(3, tmpintarray );
	tmpintarray[0]=30; tmpintarray[1]=31; tmpintarray[2]=22;	facelist[55].set(3, tmpintarray );	
	tmpintarray[0]=31; tmpintarray[1]=22; tmpintarray[2]=21;	facelist[56].set(3, tmpintarray );
	tmpintarray[0]=31; tmpintarray[1]=23; tmpintarray[2]=22;	facelist[57].set(3, tmpintarray );
	tmpintarray[0]=31; tmpintarray[1]=32; tmpintarray[2]=23;	facelist[58].set(3, tmpintarray );
	tmpintarray[0]=32; tmpintarray[1]=24; tmpintarray[2]=23;	facelist[59].set(3, tmpintarray );
	tmpintarray[0]=32; tmpintarray[1]=13; tmpintarray[2]=24;	facelist[60].set(3, tmpintarray );
	tmpintarray[0]=32; tmpintarray[1]=25; tmpintarray[2]=13;	facelist[61].set(3, tmpintarray );

	tmpintarray[0]=33; tmpintarray[1]=26; tmpintarray[2]=25;	facelist[62].set(3, tmpintarray );
	tmpintarray[0]=33; tmpintarray[1]=27; tmpintarray[2]=26;	facelist[63].set(3, tmpintarray );
	tmpintarray[0]=33; tmpintarray[1]=34; tmpintarray[2]=27;	facelist[64].set(3, tmpintarray );
	tmpintarray[0]=34; tmpintarray[1]=28; tmpintarray[2]=27;	facelist[65].set(3, tmpintarray );
	tmpintarray[0]=34; tmpintarray[1]=29; tmpintarray[2]=28;	facelist[66].set(3, tmpintarray );
	tmpintarray[0]=34; tmpintarray[1]=35; tmpintarray[2]=29;	facelist[67].set(3, tmpintarray );
	tmpintarray[0]=35; tmpintarray[1]=30; tmpintarray[2]=29;	facelist[68].set(3, tmpintarray );
	tmpintarray[0]=35; tmpintarray[1]=31; tmpintarray[2]=30;	facelist[69].set(3, tmpintarray );
	tmpintarray[0]=35; tmpintarray[1]=36; tmpintarray[2]=31;	facelist[70].set(3, tmpintarray );
	tmpintarray[0]=36; tmpintarray[1]=32; tmpintarray[2]=31;	facelist[71].set(3, tmpintarray );
	tmpintarray[0]=36; tmpintarray[1]=25; tmpintarray[2]=32;	facelist[72].set(3, tmpintarray );
	tmpintarray[0]=36; tmpintarray[1]=33; tmpintarray[2]=25;	facelist[73].set(3, tmpintarray );

	tmpintarray[0]=37; tmpintarray[1]=34; tmpintarray[2]=33;	facelist[74].set(3, tmpintarray );
	tmpintarray[0]=37; tmpintarray[1]=35; tmpintarray[2]=34;	facelist[75].set(3, tmpintarray );
	tmpintarray[0]=37; tmpintarray[1]=36; tmpintarray[2]=35;	facelist[76].set(3, tmpintarray );
	tmpintarray[0]=37; tmpintarray[1]=33; tmpintarray[2]=36;	facelist[77].set(3, tmpintarray );
	
	tmpintarray[0]=25; tmpintarray[1]=26; tmpintarray[2]=14;	facelist[78].set(3, tmpintarray );
		
}


// two calls in one function
void shape3D::setaspseudosphere(int factor)
{
	setaspseudosphere();
	scaling=factor;
}






// because sometimes cubes are faster than pseudo-spheres
void shape3D::setascube(int side)
{
	currentshapetype=2;
	int tmpintarray[4] = {0,0,0,0};
	
	// there is no checking to see if the shape has already been defined
	
	nbofptsinshape = 8;
	nboffacesinshape = 6;
	
	facelist = new face[nboffacesinshape];
	locallist = new point_3D[nbofptsinshape];
	worldlist = new point_3D[nbofptsinshape];
	alignedlist = new point_3D[nbofptsinshape];
	screenlist = new point_2D[nbofptsinshape];



	// all the points
	locallist[0].setcoords(-(side/2), -(side/2), -(side/2));
	locallist[1].setcoords( (side/2), -(side/2), -(side/2));
	locallist[2].setcoords( (side/2),  (side/2), -(side/2));
	locallist[3].setcoords(-(side/2),  (side/2), -(side/2));
	locallist[4].setcoords(-(side/2), -(side/2),  (side/2));
	locallist[5].setcoords( (side/2), -(side/2),  (side/2));
	locallist[6].setcoords( (side/2),  (side/2),  (side/2));
	locallist[7].setcoords(-(side/2),  (side/2),  (side/2));
	
	
	// all the faces
	tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=2; tmpintarray[3]=1;
	facelist[0].set(4, tmpintarray );

	tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
	facelist[1].set(4, tmpintarray );
	
	tmpintarray[0]=1; tmpintarray[1]=2; tmpintarray[2]=6; tmpintarray[3]=5;
	facelist[2].set(4, tmpintarray );	
	
	tmpintarray[0]=0; tmpintarray[1]=4; tmpintarray[2]=7; tmpintarray[3]=3;
	facelist[3].set(4, tmpintarray );
	
	tmpintarray[0]=1; tmpintarray[1]=5; tmpintarray[2]=4; tmpintarray[3]=0;
	facelist[4].set(4, tmpintarray );
	
	tmpintarray[0]=3; tmpintarray[1]=7; tmpintarray[2]=6; tmpintarray[3]=2;
	facelist[5].set(4, tmpintarray );
	
}



// two calls in one function
void shape3D::setasprofchimie(int factor)
{
	setasprofchimie();
	scaling=factor;
}



void shape3D::setasprofchimie(void)
{
	currentshapetype=3;
	int tmpintarray[4] = {0,0,0,0};
	
	// there is no checking to see if the shape has already been defined
	
	nbofptsinshape = 76;
	nboffacesinshape = 55;
	
	facelist = new face[nboffacesinshape];
	locallist = new point_3D[nbofptsinshape];
	worldlist = new point_3D[nbofptsinshape];
	alignedlist = new point_3D[nbofptsinshape];
	screenlist = new point_2D[nbofptsinshape];



	// all the points
	locallist[0].setcoords(-3,14,0);
	locallist[1].setcoords(3,14,0);
	locallist[2].setcoords(3,8,0);
	locallist[3].setcoords(-3,8,0);

	locallist[4].setcoords(-1,8,0);
	locallist[5].setcoords(1,8,0);
	locallist[6].setcoords(1,6,0);
	locallist[7].setcoords(-1,6,0);

	locallist[8].setcoords(-5,6,0);
	locallist[9].setcoords(5,6,0);
	locallist[10].setcoords(5,-8,0);
	locallist[11].setcoords(-5,-8,0);

	locallist[12].setcoords(-1,-8,0);
	locallist[13].setcoords(-1,-20,0);
	locallist[14].setcoords(-5,-20,0);

	locallist[15].setcoords(1,-8,0);
	locallist[16].setcoords(5,-20,0);
	locallist[17].setcoords(1,-20,0);
	
	locallist[18].setcoords(5,4,0);
	locallist[19].setcoords(13,4,0);
	locallist[20].setcoords(13,2,0);
	locallist[21].setcoords(5,2,0);

	locallist[22].setcoords(11,2,0);
	locallist[23].setcoords(13,-2,0);
	locallist[24].setcoords(11,-2,0);

	locallist[25].setcoords(-13,4,0);
	locallist[26].setcoords(-5,4,0);
	locallist[27].setcoords(-5,2,0);
	locallist[28].setcoords(-13,2,0);

	locallist[29].setcoords(-11,4,0);
	locallist[30].setcoords(-13,8,0);
	locallist[31].setcoords(-11,8,0);

	locallist[32].setcoords(-3,14,2);
	locallist[33].setcoords(3,14,2);
	locallist[34].setcoords(3,8,2);
	locallist[35].setcoords(-3,8,2);

	locallist[36].setcoords(-1,8,2);
	locallist[37].setcoords(1,8,2);
	locallist[38].setcoords(1,6,2);
	locallist[39].setcoords(-1,6,2);

	locallist[40].setcoords(-5,6,2);
	locallist[41].setcoords(5,6,2);
	locallist[42].setcoords(5,-8,2);
	locallist[43].setcoords(-5,-8,2);

	locallist[44].setcoords(-1,-8,2);
	locallist[45].setcoords(-1,-20,2);
	locallist[46].setcoords(-5,-20,2);

	locallist[47].setcoords(1,-8,2);
	locallist[48].setcoords(5,-20,2);
	locallist[49].setcoords(1,-20,2);
	
	locallist[50].setcoords(5,4,2);
	locallist[51].setcoords(13,4,2);
	locallist[52].setcoords(13,2,2);
	locallist[53].setcoords(5,2,2);

	locallist[54].setcoords(11,2,2);
	locallist[55].setcoords(13,-2,2);
	locallist[56].setcoords(11,-2,2);

	locallist[57].setcoords(-13,4,2);
	locallist[58].setcoords(-5,4,2);
	locallist[59].setcoords(-5,2,2);
	locallist[60].setcoords(-13,2,2);

	locallist[61].setcoords(-11,4,2);
	locallist[62].setcoords(-13,8,2);
	locallist[63].setcoords(-11,8,2);

	locallist[64].setcoords(-5,-18,0);
	locallist[65].setcoords(-1,-18,0);
	locallist[66].setcoords(1,-18,0);
	locallist[67].setcoords(5,-18,0);
	
	locallist[68].setcoords(-5,-18,-5);
	locallist[69].setcoords(-1,-18,-5);
	locallist[70].setcoords(-1,-20,-5);
	locallist[71].setcoords(-5,-20,-5);


	locallist[72].setcoords(1,-18,-5);
	locallist[73].setcoords(5,-18,-5);
	locallist[74].setcoords(5,-20,-5);
	locallist[75].setcoords(1,-20,-5);

	
	// all the faces
	tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2; tmpintarray[3]=3;
	facelist[0].set(4, tmpintarray );
	
	tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
	facelist[1].set(4, tmpintarray );
	
	tmpintarray[0]=8; tmpintarray[1]=9; tmpintarray[2]=10; tmpintarray[3]=11;
	facelist[2].set(4, tmpintarray );	
	
	tmpintarray[0]=11; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=14;
	facelist[3].set(4, tmpintarray );
	
	tmpintarray[0]=15; tmpintarray[1]=10; tmpintarray[2]=16; tmpintarray[3]=17;
	facelist[4].set(4, tmpintarray );
	
	tmpintarray[0]=22; tmpintarray[1]=20; tmpintarray[2]=23; tmpintarray[3]=24;
	facelist[5].set(4, tmpintarray );
	
	tmpintarray[0]=18; tmpintarray[1]=19; tmpintarray[2]=20; tmpintarray[3]=21;
	facelist[6].set(4, tmpintarray );

	tmpintarray[0]=25; tmpintarray[1]=26; tmpintarray[2]=27; tmpintarray[3]=28;
	facelist[7].set(4, tmpintarray );

	tmpintarray[0]=30; tmpintarray[1]=31; tmpintarray[2]=29; tmpintarray[3]=25;
	facelist[8].set(4, tmpintarray );


	tmpintarray[0]=32; tmpintarray[1]=35; tmpintarray[2]=34; tmpintarray[3]=33;
	facelist[9].set(4, tmpintarray );
	
	tmpintarray[0]=36; tmpintarray[1]=39; tmpintarray[2]=38; tmpintarray[3]=37;
	facelist[10].set(4, tmpintarray );
	
	tmpintarray[0]=40; tmpintarray[1]=43; tmpintarray[2]=42; tmpintarray[3]=41;
	facelist[11].set(4, tmpintarray );	
	
	tmpintarray[0]=43; tmpintarray[1]=46; tmpintarray[2]=45; tmpintarray[3]=44;
	facelist[12].set(4, tmpintarray );
	
	tmpintarray[0]=47; tmpintarray[1]=49; tmpintarray[2]=48; tmpintarray[3]=42;
	facelist[13].set(4, tmpintarray );
	
	tmpintarray[0]=50; tmpintarray[1]=53; tmpintarray[2]=52; tmpintarray[3]=51;
	facelist[14].set(4, tmpintarray );

	tmpintarray[0]=54; tmpintarray[1]=56; tmpintarray[2]=55; tmpintarray[3]=52;
	facelist[15].set(4, tmpintarray );
	
	tmpintarray[0]=57; tmpintarray[1]=60; tmpintarray[2]=59; tmpintarray[3]=58;
	facelist[16].set(4, tmpintarray );

	tmpintarray[0]=62; tmpintarray[1]=57; tmpintarray[2]=61; tmpintarray[3]=63;
	facelist[17].set(4, tmpintarray );

	tmpintarray[0]=0; tmpintarray[1]=32; tmpintarray[2]=33; tmpintarray[3]=1;
	facelist[18].set(4, tmpintarray );

	tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=35; tmpintarray[3]=32;
	facelist[19].set(4, tmpintarray );

	tmpintarray[0]=1; tmpintarray[1]=33; tmpintarray[2]=34; tmpintarray[3]=2;
	facelist[20].set(4, tmpintarray );

	tmpintarray[0]=5; tmpintarray[1]=3; tmpintarray[2]=35; tmpintarray[3]=37;
	facelist[21].set(4, tmpintarray );
	
	tmpintarray[0]=3; tmpintarray[1]=2; tmpintarray[2]=34; tmpintarray[3]=35;
	facelist[22].set(4, tmpintarray );

	tmpintarray[0]=6; tmpintarray[1]=5; tmpintarray[2]=37; tmpintarray[3]=38;
	facelist[23].set(4, tmpintarray );

	tmpintarray[0]=4; tmpintarray[1]=7; tmpintarray[2]=39; tmpintarray[3]=36;
	facelist[24].set(4, tmpintarray );

	tmpintarray[0]=7; tmpintarray[1]=8; tmpintarray[2]=40; tmpintarray[3]=39;
	facelist[25].set(4, tmpintarray );

	tmpintarray[0]=9; tmpintarray[1]=6; tmpintarray[2]=38; tmpintarray[3]=41;
	facelist[26].set(4, tmpintarray );

	tmpintarray[0]=9; tmpintarray[1]=41; tmpintarray[2]=42; tmpintarray[3]=10;
	facelist[27].set(4, tmpintarray );

	tmpintarray[0]=8; tmpintarray[1]=11; tmpintarray[2]=43; tmpintarray[3]=40;
	facelist[28].set(4, tmpintarray );
	
	tmpintarray[0]=10; tmpintarray[1]=42; tmpintarray[2]=48; tmpintarray[3]=16;
	facelist[29].set(4, tmpintarray );

	tmpintarray[0]=16; tmpintarray[1]=17; tmpintarray[2]=49; tmpintarray[3]=48;
	facelist[30].set(4, tmpintarray );

	tmpintarray[0]=12; tmpintarray[1]=44; tmpintarray[2]=45; tmpintarray[3]=13;
	facelist[31].set(4, tmpintarray );

	tmpintarray[0]=11; tmpintarray[1]=14; tmpintarray[2]=46; tmpintarray[3]=43;
	facelist[32].set(4, tmpintarray );

	tmpintarray[0]=28; tmpintarray[1]=27; tmpintarray[2]=59; tmpintarray[3]=60;
	facelist[33].set(4, tmpintarray );

	tmpintarray[0]=25; tmpintarray[1]=57; tmpintarray[2]=58; tmpintarray[3]=26;
	facelist[34].set(4, tmpintarray );

	tmpintarray[0]=31; tmpintarray[1]=63; tmpintarray[2]=61; tmpintarray[3]=29;
	facelist[35].set(4, tmpintarray );

	tmpintarray[0]=30; tmpintarray[1]=28; tmpintarray[2]=60; tmpintarray[3]=62;
	facelist[36].set(4, tmpintarray );

	tmpintarray[0]=30; tmpintarray[1]=62; tmpintarray[2]=63; tmpintarray[3]=31;
	facelist[37].set(4, tmpintarray );

	tmpintarray[0]=21; tmpintarray[1]=20; tmpintarray[2]=52; tmpintarray[3]=53;
	facelist[38].set(4, tmpintarray );

	tmpintarray[0]=18; tmpintarray[1]=50; tmpintarray[2]=51; tmpintarray[3]=19;
	facelist[39].set(4, tmpintarray );

	tmpintarray[0]=19; tmpintarray[1]=51; tmpintarray[2]=55; tmpintarray[3]=23;
	facelist[40].set(4, tmpintarray );

	tmpintarray[0]=22; tmpintarray[1]=24; tmpintarray[2]=56; tmpintarray[3]=54;
	facelist[41].set(4, tmpintarray );

	tmpintarray[0]=24; tmpintarray[1]=23; tmpintarray[2]=55; tmpintarray[3]=56;
	facelist[42].set(4, tmpintarray );

	tmpintarray[0]=14; tmpintarray[1]=13; tmpintarray[2]=45; tmpintarray[3]=46;
	facelist[43].set(4, tmpintarray );

	tmpintarray[0]=15; tmpintarray[1]=17; tmpintarray[2]=49; tmpintarray[3]=47;
	facelist[44].set(4, tmpintarray );

	tmpintarray[0]=66; tmpintarray[1]=67; tmpintarray[2]=73; tmpintarray[3]=72;
	facelist[45].set(4, tmpintarray );

	tmpintarray[0]=16; tmpintarray[1]=74; tmpintarray[2]=73; tmpintarray[3]=67;
	facelist[46].set(4, tmpintarray );

	tmpintarray[0]=48; tmpintarray[1]=49; tmpintarray[2]=75; tmpintarray[3]=74;
	facelist[47].set(4, tmpintarray );
	
	tmpintarray[0]=72; tmpintarray[1]=75; tmpintarray[2]=17; tmpintarray[3]=66;
	facelist[48].set(4, tmpintarray );

	tmpintarray[0]=72; tmpintarray[1]=73; tmpintarray[2]=74; tmpintarray[3]=75;
	facelist[49].set(4, tmpintarray );

	tmpintarray[0]=68; tmpintarray[1]=69; tmpintarray[2]=70; tmpintarray[3]=71;
	facelist[50].set(4, tmpintarray );

	tmpintarray[0]=64; tmpintarray[1]=65; tmpintarray[2]=69; tmpintarray[3]=68;
	facelist[51].set(4, tmpintarray );

	tmpintarray[0]=13; tmpintarray[1]=14; tmpintarray[2]=71; tmpintarray[3]=70;
	facelist[52].set(4, tmpintarray );

	tmpintarray[0]=68; tmpintarray[1]=71; tmpintarray[2]=14; tmpintarray[3]=64;
	facelist[53].set(4, tmpintarray );

	tmpintarray[0]=69; tmpintarray[1]=65; tmpintarray[2]=13; tmpintarray[3]=70;
	facelist[54].set(4, tmpintarray );

}



// two calls in one function

void shape3D::setasletter(int letter, int factor)
{
	setasletter(letter);
	scaling=factor;
}



void shape3D::setasletter(int letter)
{
	currentshapetype=4;
	int tmpintarray[4] = {0,0,0,0};
	
	// there is no checking to see if the shape has already been defined
	
	
	switch(letter)
		{

		case 1: // letter A
	
	
			nbofptsinshape = 24;
			nboffacesinshape = 22;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(0,4,0);
			locallist[1].setcoords(4,0,0);
			locallist[2].setcoords(4,-4,0);
			locallist[3].setcoords(1,-4,0);
			locallist[4].setcoords(1,-1,0);
			locallist[5].setcoords(-1,-1,0);
			locallist[6].setcoords(-1,-4,0);
			locallist[7].setcoords(-4,-4,0);
			locallist[8].setcoords(-4,0,0);
			locallist[9].setcoords(-1,0,0);
			locallist[10].setcoords(0,2,0);
			locallist[11].setcoords(1,0,0);

			locallist[12].setcoords(0,4,2);
			locallist[13].setcoords(4,0,2);
			locallist[14].setcoords(4,-4,2);
			locallist[15].setcoords(1,-4,2);
			locallist[16].setcoords(1,-1,2);
			locallist[17].setcoords(-1,-1,2);
			locallist[18].setcoords(-1,-4,2);
			locallist[19].setcoords(-4,-4,2);
			locallist[20].setcoords(-4,0,2);
			locallist[21].setcoords(-1,0,2);
			locallist[22].setcoords(0,2,2);
			locallist[23].setcoords(1,0,2);
	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=11; tmpintarray[3]=10;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=1; tmpintarray[1]=2; tmpintarray[2]=3; tmpintarray[3]=11;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=9; tmpintarray[1]=11; tmpintarray[2]=4; tmpintarray[3]=5;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=6; tmpintarray[1]=7; tmpintarray[2]=8; tmpintarray[3]=9;
			facelist[3].set(4, tmpintarray );

			tmpintarray[0]=8; tmpintarray[1]=0; tmpintarray[2]=10; tmpintarray[3]=9;
			facelist[4].set(4, tmpintarray );


			tmpintarray[0]=12; tmpintarray[1]=22; tmpintarray[2]=23; tmpintarray[3]=13;
			facelist[5].set(4, tmpintarray );

			tmpintarray[0]=13; tmpintarray[1]=23; tmpintarray[2]=15; tmpintarray[3]=14;
			facelist[6].set(4, tmpintarray );
 
			tmpintarray[0]=21; tmpintarray[1]=17; tmpintarray[2]=16; tmpintarray[3]=23;
			facelist[7].set(4, tmpintarray );	
	
			tmpintarray[0]=18; tmpintarray[1]=21; tmpintarray[2]=20; tmpintarray[3]=19;
			facelist[8].set(4, tmpintarray );

			tmpintarray[0]=20; tmpintarray[1]=21; tmpintarray[2]=22; tmpintarray[3]=12;
			facelist[9].set(4, tmpintarray );


			tmpintarray[0]=0; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=1;
			facelist[10].set(4, tmpintarray );

			tmpintarray[0]=1; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=2;
			facelist[11].set(4, tmpintarray );
	
			tmpintarray[0]=3; tmpintarray[1]=2; tmpintarray[2]=14; tmpintarray[3]=15;
			facelist[12].set(4, tmpintarray );	
	
			tmpintarray[0]=4; tmpintarray[1]=3; tmpintarray[2]=15; tmpintarray[3]=16;
			facelist[13].set(4, tmpintarray );

			tmpintarray[0]=5; tmpintarray[1]=4; tmpintarray[2]=16; tmpintarray[3]=17;
			facelist[14].set(4, tmpintarray );

			tmpintarray[0]=5; tmpintarray[1]=17; tmpintarray[2]=18; tmpintarray[3]=6;
			facelist[15].set(4, tmpintarray );

			tmpintarray[0]=7; tmpintarray[1]=6; tmpintarray[2]=18; tmpintarray[3]=19;
			facelist[16].set(4, tmpintarray );
	
			tmpintarray[0]=8; tmpintarray[1]=7; tmpintarray[2]=19; tmpintarray[3]=20;
			facelist[17].set(4, tmpintarray );	
	
			tmpintarray[0]=0; tmpintarray[1]=8; tmpintarray[2]=20; tmpintarray[3]=12;
			facelist[18].set(4, tmpintarray );

			tmpintarray[0]=9; tmpintarray[1]=10; tmpintarray[2]=22; tmpintarray[3]=21;
			facelist[19].set(4, tmpintarray );

			tmpintarray[0]=10; tmpintarray[1]=11; tmpintarray[2]=23; tmpintarray[3]=22;
			facelist[20].set(4, tmpintarray );

			tmpintarray[0]=9; tmpintarray[1]=21; tmpintarray[2]=23; tmpintarray[3]=11;
			facelist[21].set(4, tmpintarray );

			break;	
			


		case 3: // letter C

	
			nbofptsinshape = 16;
			nboffacesinshape = 14;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-4,4,0);
			locallist[1].setcoords(4,4,0);
			locallist[2].setcoords(4,1,0);
			locallist[3].setcoords(-1,2,0);
			locallist[4].setcoords(-1,-2,0);
			locallist[5].setcoords(4,-1,0);
			locallist[6].setcoords(4,-4,0);
			locallist[7].setcoords(-4,-4,0);

			locallist[8].setcoords(-4,4,2);
			locallist[9].setcoords(4,4,2);
			locallist[10].setcoords(4,1,2);
			locallist[11].setcoords(-1,2,2);
			locallist[12].setcoords(-1,-2,2);
			locallist[13].setcoords(4,-1,2);
			locallist[14].setcoords(4,-4,2);
			locallist[15].setcoords(-4,-4,2);

	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2; tmpintarray[3]=3;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=4; tmpintarray[3]=7;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=8; tmpintarray[1]=11; tmpintarray[2]=10; tmpintarray[3]=9;
			facelist[3].set(4, tmpintarray );

			tmpintarray[0]=8; tmpintarray[1]=15; tmpintarray[2]=12; tmpintarray[3]=11;
			facelist[4].set(4, tmpintarray );
	
			tmpintarray[0]=12; tmpintarray[1]=15; tmpintarray[2]=14; tmpintarray[3]=13;
			facelist[5].set(4, tmpintarray );	


	
			tmpintarray[0]=0; tmpintarray[1]=8; tmpintarray[2]=9; tmpintarray[3]=1;
			facelist[6].set(4, tmpintarray );	
	
			tmpintarray[0]=1; tmpintarray[1]=9; tmpintarray[2]=10; tmpintarray[3]=2;
			facelist[7].set(4, tmpintarray );
	
			tmpintarray[0]=2; tmpintarray[1]=10; tmpintarray[2]=11; tmpintarray[3]=3;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=3; tmpintarray[1]=11; tmpintarray[2]=12; tmpintarray[3]=4;
			facelist[9].set(4, tmpintarray );

			tmpintarray[0]=4; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=5;
			facelist[10].set(4, tmpintarray );
	
			tmpintarray[0]=5; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=6;
			facelist[11].set(4, tmpintarray );

			tmpintarray[0]=7; tmpintarray[1]=6; tmpintarray[2]=14; tmpintarray[3]=15;
			facelist[12].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=7; tmpintarray[2]=15; tmpintarray[3]=8;
			facelist[13].set(4, tmpintarray );

			break;
		
		case 5: // letter E
	
	
			nbofptsinshape = 24;
			nboffacesinshape = 20;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-4,4,0);
			locallist[1].setcoords(4,4,0);
			locallist[2].setcoords(4,1,0);
			locallist[3].setcoords(-1,2,0);
			locallist[4].setcoords(-1,1,0);
			locallist[5].setcoords(0,1,0);
			locallist[6].setcoords(0,-1,0);
			locallist[7].setcoords(-1,-1,0);
			locallist[8].setcoords(-1,-2,0);
			locallist[9].setcoords(4,-1,0);
			locallist[10].setcoords(4,-4,0);
			locallist[11].setcoords(-4,-4,0);
			
			locallist[12].setcoords(-4,4,2);
			locallist[13].setcoords(4,4,2);
			locallist[14].setcoords(4,1,2);
			locallist[15].setcoords(-1,2,2);
			locallist[16].setcoords(-1,1,2);
			locallist[17].setcoords(0,1,2);
			locallist[18].setcoords(0,-1,2);
			locallist[19].setcoords(-1,-1,2);
			locallist[20].setcoords(-1,-2,2);
			locallist[21].setcoords(4,-1,2);
			locallist[22].setcoords(4,-4,2);
			locallist[23].setcoords(-4,-4,2);

	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2; tmpintarray[3]=3;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=8; tmpintarray[3]=11;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=8; tmpintarray[1]=9; tmpintarray[2]=10; tmpintarray[3]=11;
			facelist[3].set(4, tmpintarray );


			tmpintarray[0]=12; tmpintarray[1]=15; tmpintarray[2]=14; tmpintarray[3]=13;
			facelist[4].set(4, tmpintarray );

			tmpintarray[0]=12; tmpintarray[1]=23; tmpintarray[2]=20; tmpintarray[3]=15;
			facelist[5].set(4, tmpintarray );
	
			tmpintarray[0]=16; tmpintarray[1]=19; tmpintarray[2]=18; tmpintarray[3]=17;
			facelist[6].set(4, tmpintarray );	
	
			tmpintarray[0]=20; tmpintarray[1]=23; tmpintarray[2]=22; tmpintarray[3]=21;
			facelist[7].set(4, tmpintarray );
	
	
			tmpintarray[0]=0; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=1;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=1; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=2;
			facelist[9].set(4, tmpintarray );

			tmpintarray[0]=3; tmpintarray[1]=2; tmpintarray[2]=14; tmpintarray[3]=15;
			facelist[10].set(4, tmpintarray );
	
			tmpintarray[0]=3; tmpintarray[1]=15; tmpintarray[2]=16; tmpintarray[3]=4;
			facelist[11].set(4, tmpintarray );

			
			tmpintarray[0]=4; tmpintarray[1]=16; tmpintarray[2]=17; tmpintarray[3]=5;
			facelist[12].set(4, tmpintarray );
	
			tmpintarray[0]=5; tmpintarray[1]=17; tmpintarray[2]=18; tmpintarray[3]=6;
			facelist[13].set(4, tmpintarray );

			tmpintarray[0]=7; tmpintarray[1]=6; tmpintarray[2]=18; tmpintarray[3]=19;
			facelist[14].set(4, tmpintarray );
	
			tmpintarray[0]=7; tmpintarray[1]=19; tmpintarray[2]=20; tmpintarray[3]=8;
			facelist[15].set(4, tmpintarray );


			tmpintarray[0]=8; tmpintarray[1]=20; tmpintarray[2]=21; tmpintarray[3]=9;
			facelist[16].set(4, tmpintarray );
	
			tmpintarray[0]=9; tmpintarray[1]=21; tmpintarray[2]=22; tmpintarray[3]=10;
			facelist[17].set(4, tmpintarray );

			tmpintarray[0]=11; tmpintarray[1]=10; tmpintarray[2]=22; tmpintarray[3]=23;
			facelist[18].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=11; tmpintarray[2]=23; tmpintarray[3]=12;
			facelist[19].set(4, tmpintarray );
									
			break;
			
		
		case 8: // letter h

	
			nbofptsinshape = 24;
			nboffacesinshape = 18;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-4,4,0);
			locallist[1].setcoords(-1,4,0);
			locallist[2].setcoords(-1,1,0);
			locallist[3].setcoords(1,1,0);
			locallist[4].setcoords(1,4,0);
			locallist[5].setcoords(4,4,0);
			locallist[6].setcoords(4,-4,0);
			locallist[7].setcoords(1,-4,0);
			locallist[8].setcoords(1,-1,0);
			locallist[9].setcoords(-1,-1,0);
			locallist[10].setcoords(-1,-4,0);
			locallist[11].setcoords(-4,-4,0);
			
			locallist[12].setcoords(-4,4,2);
			locallist[13].setcoords(-1,4,2);
			locallist[14].setcoords(-1,1,2);
			locallist[15].setcoords(1,1,2);
			locallist[16].setcoords(1,4,2);
			locallist[17].setcoords(4,4,2);
			locallist[18].setcoords(4,-4,2);
			locallist[19].setcoords(1,-4,2);
			locallist[20].setcoords(1,-1,2);
			locallist[21].setcoords(-1,-1,2);
			locallist[22].setcoords(-1,-4,2);
			locallist[23].setcoords(-4,-4,2);
	
	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=10; tmpintarray[3]=11;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=2; tmpintarray[1]=3; tmpintarray[2]=8; tmpintarray[3]=9;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=12; tmpintarray[1]=23; tmpintarray[2]=22; tmpintarray[3]=13;
			facelist[3].set(4, tmpintarray );

			tmpintarray[0]=14; tmpintarray[1]=21; tmpintarray[2]=20; tmpintarray[3]=15;
			facelist[4].set(4, tmpintarray );
	
			tmpintarray[0]=16; tmpintarray[1]=19; tmpintarray[2]=18; tmpintarray[3]=17;
			facelist[5].set(4, tmpintarray );	

	
			tmpintarray[0]=0; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=1;
			facelist[6].set(4, tmpintarray );	
	
			tmpintarray[0]=1; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=2;
			facelist[7].set(4, tmpintarray );
	
			tmpintarray[0]=2; tmpintarray[1]=14; tmpintarray[2]=15; tmpintarray[3]=3;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=4; tmpintarray[1]=3; tmpintarray[2]=15; tmpintarray[3]=16;
			facelist[9].set(4, tmpintarray );

			tmpintarray[0]=4; tmpintarray[1]=16; tmpintarray[2]=17; tmpintarray[3]=5;
			facelist[10].set(4, tmpintarray );
	
			tmpintarray[0]=5; tmpintarray[1]=17; tmpintarray[2]=18; tmpintarray[3]=6;
			facelist[11].set(4, tmpintarray );

			tmpintarray[0]=7; tmpintarray[1]=6; tmpintarray[2]=18; tmpintarray[3]=19;
			facelist[12].set(4, tmpintarray );
	
			tmpintarray[0]=8; tmpintarray[1]=7; tmpintarray[2]=19; tmpintarray[3]=20;
			facelist[13].set(4, tmpintarray );

			tmpintarray[0]=9; tmpintarray[1]=8; tmpintarray[2]=20; tmpintarray[3]=21;
			facelist[14].set(4, tmpintarray );
	
			tmpintarray[0]=9; tmpintarray[1]=21; tmpintarray[2]=22; tmpintarray[3]=10;
			facelist[15].set(4, tmpintarray );

			tmpintarray[0]=11; tmpintarray[1]=10; tmpintarray[2]=22; tmpintarray[3]=23;
			facelist[16].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=11; tmpintarray[2]=23; tmpintarray[3]=12;
			facelist[17].set(4, tmpintarray );

			break;

		
		case 9: // letter I
	
	
			nbofptsinshape = 16;
			nboffacesinshape = 12;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-2,4,0);
			locallist[1].setcoords(2,4,0);
			locallist[2].setcoords(2,3,0);
			locallist[3].setcoords(-2,3,0);
			locallist[4].setcoords(-2,1,0);
			locallist[5].setcoords(2,1,0);
			locallist[6].setcoords(2,-4,0);
			locallist[7].setcoords(-2,-4,0);
			locallist[8].setcoords(-2,4,2);
			locallist[9].setcoords(2,4,2);
			locallist[10].setcoords(2,3,2);
			locallist[11].setcoords(-2,3,2);
			locallist[12].setcoords(-2,1,2);
			locallist[13].setcoords(2,1,2);
			locallist[14].setcoords(2,-4,2);
			locallist[15].setcoords(-2,-4,2);

	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2; tmpintarray[3]=3;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=4; tmpintarray[1]=5; tmpintarray[2]=6; tmpintarray[3]=7;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=8; tmpintarray[1]=11; tmpintarray[2]=10; tmpintarray[3]=9;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=12; tmpintarray[1]=15; tmpintarray[2]=14; tmpintarray[3]=13;
			facelist[3].set(4, tmpintarray );


			tmpintarray[0]=1; tmpintarray[1]=9; tmpintarray[2]=10; tmpintarray[3]=2;
			facelist[4].set(4, tmpintarray );

			tmpintarray[0]=3; tmpintarray[1]=2; tmpintarray[2]=10; tmpintarray[3]=11;
			facelist[5].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=3; tmpintarray[2]=11; tmpintarray[3]=8;
			facelist[6].set(4, tmpintarray );	
	
			tmpintarray[0]=0; tmpintarray[1]=8; tmpintarray[2]=9; tmpintarray[3]=1;
			facelist[7].set(4, tmpintarray );
	
	
			tmpintarray[0]=4; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=5;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=5; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=6;
			facelist[9].set(4, tmpintarray );

			tmpintarray[0]=7; tmpintarray[1]=6; tmpintarray[2]=14; tmpintarray[3]=15;
			facelist[10].set(4, tmpintarray );
	
			tmpintarray[0]=4; tmpintarray[1]=7; tmpintarray[2]=15; tmpintarray[3]=12;
			facelist[11].set(4, tmpintarray );
			break;

		case 12:	// letter L
	
	
			nbofptsinshape = 12;
			nboffacesinshape = 10;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-4,4,0);
			locallist[1].setcoords(-1,4,0);
			locallist[2].setcoords(-1,-2,0);
			locallist[3].setcoords(4,0,0);
			locallist[4].setcoords(4,-4,0);
			locallist[5].setcoords(-4,-4,0);
			locallist[6].setcoords(-4,4,2);
			locallist[7].setcoords(-1,4,2);
			locallist[8].setcoords(-1,-2,2);
			locallist[9].setcoords(4,0,2);
			locallist[10].setcoords(4,-4,2);
			locallist[11].setcoords(-4,-4,2);

	
			// all the faces
			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=2; tmpintarray[3]=5;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=2; tmpintarray[1]=3; tmpintarray[2]=4; tmpintarray[3]=5;
			facelist[1].set(4, tmpintarray );
	
			tmpintarray[0]=6; tmpintarray[1]=11; tmpintarray[2]=8; tmpintarray[3]=7;
			facelist[2].set(4, tmpintarray );	
	
			tmpintarray[0]=8; tmpintarray[1]=11; tmpintarray[2]=10; tmpintarray[3]=9;
			facelist[3].set(4, tmpintarray );


			tmpintarray[0]=0; tmpintarray[1]=6; tmpintarray[2]=7; tmpintarray[3]=1;
			facelist[4].set(4, tmpintarray );

			tmpintarray[0]=1; tmpintarray[1]=7; tmpintarray[2]=8; tmpintarray[3]=2;
			facelist[5].set(4, tmpintarray );
	
			tmpintarray[0]=2; tmpintarray[1]=8; tmpintarray[2]=9; tmpintarray[3]=3;
			facelist[6].set(4, tmpintarray );	
	
			tmpintarray[0]=3; tmpintarray[1]=9; tmpintarray[2]=10; tmpintarray[3]=4;
			facelist[7].set(4, tmpintarray );
	
	
			tmpintarray[0]=5; tmpintarray[1]=4; tmpintarray[2]=10; tmpintarray[3]=11;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=5; tmpintarray[2]=11; tmpintarray[3]=6;
			facelist[9].set(4, tmpintarray );


			break;	




		case 13:	// letter M
	
	
			nbofptsinshape = 20;
			nboffacesinshape = 18;
	
			facelist = new face[nboffacesinshape];
			locallist = new point_3D[nbofptsinshape];
			worldlist = new point_3D[nbofptsinshape];
			alignedlist = new point_3D[nbofptsinshape];
			screenlist = new point_2D[nbofptsinshape];



			// all the points
			locallist[0].setcoords(-4,4,0);
			locallist[1].setcoords(0,2,0);
			locallist[2].setcoords(4,4,0);
			locallist[3].setcoords(4,-4,0);
			locallist[4].setcoords(2,-4,0);
			locallist[5].setcoords(2,2,0);
			locallist[6].setcoords(0,0,0);
			locallist[7].setcoords(-2,2,0);
			locallist[8].setcoords(-2,-4,0);
			locallist[9].setcoords(-4,-4,0);
			locallist[10].setcoords(-4,4,2);
			locallist[11].setcoords(0,2,2);
			locallist[12].setcoords(4,4,2);
			locallist[13].setcoords(4,-4,2);
			locallist[14].setcoords(2,-4,2);
			locallist[15].setcoords(2,2,2);
			locallist[16].setcoords(0,0,2);
			locallist[17].setcoords(-2,2,2);
			locallist[18].setcoords(-2,-4,2);
			locallist[19].setcoords(-4,-4,2);	
	
			// all the faces
	
			tmpintarray[0]=5; tmpintarray[1]=15; tmpintarray[2]=16; tmpintarray[3]=6;
			facelist[0].set(4, tmpintarray );

			tmpintarray[0]=6; tmpintarray[1]=16; tmpintarray[2]=17; tmpintarray[3]=7;
			facelist[1].set(4, tmpintarray );
			
			tmpintarray[0]=0; tmpintarray[1]=10; tmpintarray[2]=11; tmpintarray[3]=1;
			facelist[2].set(4, tmpintarray );
	
			tmpintarray[0]=1; tmpintarray[1]=11; tmpintarray[2]=12; tmpintarray[3]=2;
			facelist[3].set(4, tmpintarray );

			tmpintarray[0]=2; tmpintarray[1]=12; tmpintarray[2]=13; tmpintarray[3]=3;
			facelist[4].set(4, tmpintarray );
	
			tmpintarray[0]=3; tmpintarray[1]=13; tmpintarray[2]=14; tmpintarray[3]=4;
			facelist[5].set(4, tmpintarray );

			tmpintarray[0]=4; tmpintarray[1]=14; tmpintarray[2]=15; tmpintarray[3]=5;
			facelist[6].set(4, tmpintarray );
	
			tmpintarray[0]=7; tmpintarray[1]=17; tmpintarray[2]=18; tmpintarray[3]=8;
			facelist[7].set(4, tmpintarray );

			tmpintarray[0]=9; tmpintarray[1]=8; tmpintarray[2]=18; tmpintarray[3]=19;
			facelist[8].set(4, tmpintarray );
	
			tmpintarray[0]=0; tmpintarray[1]=9; tmpintarray[2]=19; tmpintarray[3]=10;
			facelist[9].set(4, tmpintarray );



			tmpintarray[0]=0; tmpintarray[1]=1; tmpintarray[2]=6; tmpintarray[3]=7;
			facelist[10].set(4, tmpintarray );

			tmpintarray[0]=0; tmpintarray[1]=7; tmpintarray[2]=8; tmpintarray[3]=9;
			facelist[11].set(4, tmpintarray );
	
			tmpintarray[0]=1; tmpintarray[1]=2; tmpintarray[2]=5; tmpintarray[3]=6;
			facelist[12].set(4, tmpintarray );	
	
			tmpintarray[0]=2; tmpintarray[1]=3; tmpintarray[2]=4; tmpintarray[3]=5;
			facelist[13].set(4, tmpintarray );

			tmpintarray[0]=11; tmpintarray[1]=10; tmpintarray[2]=17; tmpintarray[3]=16;
			facelist[14].set(4, tmpintarray );

			tmpintarray[0]=10; tmpintarray[1]=19; tmpintarray[2]=18; tmpintarray[3]=17;
			facelist[15].set(4, tmpintarray );
	
			tmpintarray[0]=11; tmpintarray[1]=16; tmpintarray[2]=15; tmpintarray[3]=12;
			facelist[16].set(4, tmpintarray );	
	
			tmpintarray[0]=12; tmpintarray[1]=15; tmpintarray[2]=14; tmpintarray[3]=13;
			facelist[17].set(4, tmpintarray );
					
			break;
		}
}












// clear up memory
void shape3D::setasnothing(void)
{

	delete [] facelist;
	facelist=0;

	delete [] screenlist;
	screenlist=0;

	delete [] alignedlist;
	alignedlist=0;
		
	delete [] worldlist;
	worldlist=0;
	
	delete [] locallist;
	locallist=0;

	nbofptsinshape=0;
	nboffacesinshape=0;
	locallistdeleted=0;
	
	scaling=1;

	// doing this would make us forget what type it was
	//	currentshapetype=0;	
	//	currentatom=0;
	
}






// draw the shape on a bitmap
void shape3D::displayshape(BITMAP *bitmap)
{
   int i=0,j=0;

   float x1,y1,z1,x2,y2,z2,x3,y3,z3,m;

   int *points;

   // defined to a static 8 because our largest faces have 4 sides (*2 coords)
   // we could change this to being dynamic, but we want to use simple faces... however, this will make for ugly letters
   points = new int[8];
   
   float D;
   int myColor=0,iDraw,allIn=1,allOut=1;
   

   for (i=0;i<nboffacesinshape;i++)
		{

		allIn=1; allOut=1;

		// z-checking
		for (j=0;j<facelist[i].nbofptsinface;j++)
			{
			
			if (alignedlist[ facelist[i].points[j] ].z < 11)
				{
				allOut=0;
				}
			else
				{
				allIn=0;
				}
			}

		// if half-in or half-out, take the points that are out and convert them to points that are in.
		if (!allIn && !allOut)
			{
			
			for (j=0;j<facelist[i].nbofptsinface;j++)
				{

				// if point is outside
				if ( alignedlist[ facelist[i].points[j] ].z > 11 )
					{
					// define two points, the point that is outside and the next one
					if ( j != ( facelist[i].nbofptsinface-1 ) )
						{
						x1=alignedlist[ facelist[i].points[j] ].x;
						x2=alignedlist[ facelist[i].points[j+1] ].x;
						y1=alignedlist[ facelist[i].points[j] ].y;
						y2=alignedlist[ facelist[i].points[j+1] ].y;
						z1=alignedlist[ facelist[i].points[j] ].z;
						z2=alignedlist[ facelist[i].points[j+1] ].z;
						}
					else
						{
						x1=alignedlist[ facelist[i].points[j] ].x;
						x2=alignedlist[ facelist[i].points[0] ].x;
						y1=alignedlist[ facelist[i].points[j] ].y;
						y2=alignedlist[ facelist[i].points[0] ].y;
						z1=alignedlist[ facelist[i].points[j] ].z;
						z2=alignedlist[ facelist[i].points[0] ].z;
						}				

					// find the variation; used to calculate where the point is in
					m = (z2-z1) ? (10-z1)/(z2-z1) : (10-z1);
					
					//define the new points	
					alignedlist[ facelist[i].points[j] ].x = x1+(x2-x1)*m;
					alignedlist[ facelist[i].points[j] ].y = y1+(y2-y1)*m;
					alignedlist[ facelist[i].points[j] ].z = 10;
					}
					
					
				}

			// now they are all in !
			allIn=1;
			}			
			
		// now get the first three points
		x1=alignedlist[ facelist[i].points[0] ].x;
		y1=alignedlist[ facelist[i].points[0] ].y;
		z1=alignedlist[ facelist[i].points[0] ].z;
		x2=alignedlist[ facelist[i].points[1] ].x;
		y2=alignedlist[ facelist[i].points[1] ].y;
		z2=alignedlist[ facelist[i].points[1] ].z;
		x3=alignedlist[ facelist[i].points[2] ].x;
		y3=alignedlist[ facelist[i].points[2] ].y;
		z3=alignedlist[ facelist[i].points[2] ].z;


				
		// commented to make engine faster
		//A=y1*(x2-z3)+y2*(z3-z1)+y3*(z1-z2);
		//B=z1*(x2-x3)+z2*(x3-x1)+z3*(x1-x2);
		//C=x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2);
		
		// mixed product of the three vectors. is the volume positive or negative?
		// because of the way we defined our coordinate system, we multiply D by -1
		D=-x1*(y2*z3-y3*z2)-x2*(y3*z1-y1*z3)-x3*(y1*z2-y2*z1);

		// if volume is positive, draw
		iDraw = (D>0) && (allOut)? 1:0;
		
	
		
		if (iDraw)
			{						
			// which color (depending on the atom)
			switch(currentatom)
				{
				case 1:
					myColor=makecol(255,255,51); //67; (jaune)
					break;
				case 6:
					myColor=makecol(51,204,255); //77; (cyan)
					break;
				case 7:
					myColor=makecol(51,255,51); //70; (green)
					break;
				case 8:
					myColor=makecol(51,51,255); //74; (blue)
					break;
				case 16:
					myColor=makecol(204,51,255); //81; (purple)
					break;
				case 500:
					myColor=makecol(255,51,133); //60; (purple-pink)
					break;
				default:
					myColor=makecol(255,51,51); //64; (red)
					break;
				}
				

		
			if (facelist[i].nbofptsinface==3) 
				{
				// display filled triangle
				triangle(bitmap,
					(int) screenlist[ facelist[i].points[0]    ].x,
					(int) screenlist[ facelist[i].points[0]    ].y,
					(int) screenlist[ facelist[i].points[1]    ].x,
					(int) screenlist[ facelist[i].points[1]    ].y,
					(int) screenlist[ facelist[i].points[2]    ].x,
					(int) screenlist[ facelist[i].points[2]    ].y,
					myColor-makecol(15,15,20)); // make the atom outline color brighter
				}
			
			else
				{
				// generate array
				for (j=0;j<facelist[i].nbofptsinface;j++)
					{
					points[2*j]= (int) screenlist [ facelist[i].points[j] ].x;
					points[2*j+1]= (int) screenlist [ facelist[i].points[j] ].y;
					}
				
				// display filled polygon
				polygon(bitmap, facelist[i].nbofptsinface, points,	myColor-makecol(15,15,15));
				}


			
			// in wireframe, we only had this; re-use of x1,y1 and x2,y2
			for (j=0;j<facelist[i].nbofptsinface;j++)
				{
				// display border lines

				x1=(int) screenlist[ facelist[i].points[j]    ].x;
				y1=(int) screenlist[ facelist[i].points[j]    ].y;
				if (j==facelist[i].nbofptsinface-1) 
					{
					x2=(int) screenlist[ facelist[i].points[0]    ].x;
					y2=(int) screenlist[ facelist[i].points[0]    ].y;
					}
				else
					{
					x2=(int) screenlist[ facelist[i].points[j+1]    ].x;
					y2=(int) screenlist[ facelist[i].points[j+1]    ].y;
					}

				line(bitmap, (int) x1, (int) y1, (int) x2, (int) y2, myColor);

				}



			}
		
		}
	
	// clear memory
	delete [] points;
	points=0;
}




